/**
	engine constant definitions
 */
#define Engine_Version 1.00.0.53
#if !defined(ENGINE_CONSTANT_H)
#define ENGINE_CONSTANT_H

#define MY_MAGIC				0x5A

#define SECTOR_SIZE				0x0200
#if defined(ENABLE_BACKUP)
#define DIRTY_TABLE_LENGTH		SECTOR_SIZE  
#endif
#define SECTOR_SHIFT			0x09
#define SECTOR_SIZE_MASK		0x01FF
#if defined(ATI)
#define MAX_BLOCKS				(MAX_DISK_SUPPORTED*MAX_BLOCK_PER_DISK)
#else
#define MAX_BLOCKS				MAX_EXTENTS_SUPPORTED
#endif
#define MAX_ARRAY_SUPPORTED		MAX_LD_SUPPORTED

#define ACTUAL_ARRAY_SUPPORTED	MAX_ARRAY_SUPPORTED

#if defined(ALLOW_ARRAY_ON_SAME_PD)
#define MAX_STREAM_PER_ARRAY	MAX_BLOCKS
#else
#if defined(ATI)		//change define for AMD(ATI) by tammy
#define MAX_STREAM_PER_ARRAY	6
#else
#define MAX_STREAM_PER_ARRAY	MAX_DISK_SUPPORTED
#endif
#endif

#define VALID_STREAM_ID(bStream)	((bStream)<MAX_STREAM_PER_ARRAY)
#define VALID_ARRAY_ID(bArray)		((bArray)<MAX_ARRAY_SUPPORTED)

/* for Block ID and Disk ID, refer to REF_01_29_2004_01 */
#define VALID_BLOCK_ID(bBlk)		((bBlk)<MAX_BLOCKS)
#define VALID_DISK_ID(bDiskID)		((bDiskID)<MAX_DISK_SUPPORTED)

#define ENG_SENSE_INFO_SIZE			16

#endif /* ENGINE_CONSTANT_H */

