/**
	engine data type definitions
 */
#if !defined(ENGINE_TYPES_H)
#define ENGINE_TYPES_H

#include "gen_typs.h"

/* please avoid using WORD since it is conflict with Windows definition */
//typedef U32	WORD;
//typedef U8	BoOL;

#define kNULL 0

#if !defined(TRUE)
#define TRUE 1
#endif

#if !defined(FALSE)
#define FALSE 0
#endif

typedef ByTE app_space *apBUF;
typedef HALF app_space *aphBUF;
typedef U32 app_space *apwBUF;
typedef BoOL app_space *apBoOL;

typedef ByTE buf_space *bpBUF;
typedef HALF buf_space *bphBUF;
typedef U32 buf_space *bpwBUF;
typedef BoOL buf_space *bpBoOL;

typedef ByTE dat_space *dpBUF;
typedef HALF dat_space *dphBUF;
typedef U32 dat_space *dpwBUF;
typedef BoOL dat_space *dpBoOL;

typedef ByTE str_space *spBUF;
typedef HALF str_space *sphBUF;
typedef U32 str_space *spwBUF;
typedef BoOL str_space *spBoOL;


struct req;
typedef struct req REQ, buf_space* bpREQ;

struct dtask;
typedef struct dtask DTASK, buf_space* bpDTASK;

struct _RaidEngine;
typedef struct _RaidEngine RaidEngine, buf_space* bpRaidEngine;

struct seq;
typedef struct seq SEQ, buf_space *bpSEQ, str_space *spSEQ;

struct q;
typedef struct q Q, buf_space *bpQ, str_space *spQ;

#define DECLARE_ENG_Q_HEADER	\
	bpQ		p_next;				\
	bpQ		p_link;

struct event;
typedef struct event EVENT, buf_space *bpEVENT;

struct logevent;
typedef struct logevent LOGEVENT, buf_space *bpLOGEVENT;

struct erlog;
typedef struct erlog ERLOG,buf_space *bpERLOG;

struct _AccessMap;
typedef struct _AccessMap AccessMap, buf_space* bpAccessMap;

struct readmap;
typedef struct readmap READMAP, buf_space *bpREADMAP;

struct array;
typedef struct array ARY, buf_space* bpARY, dat_space* dpARY;

struct	block;
typedef struct	block BLOCK, buf_space * bpBLOCK, dat_space * dpBLOCK;

struct _StripeLines;
typedef struct _StripeLines StripeLines, buf_space * bpStripeLines;

struct map;
typedef struct map MAP, buf_space * bpMAP;

typedef void (GEN_CALLBACK *RequestCompletion ) ( IN bpVOID Sender, IN bpREQ p_rq );

typedef U8 ( *RequestOnTaskError ) ( IN bpRaidEngine This, IN bpREQ p_rq, IN bpDTASK p_tk, IN PTR_SIZE context );

#endif /* ENGINE_TYPES_H */
