#if !defined(OSD_DIMM_H)
#define OSD_DIMM_H

#include "osd_exp.h"

#if defined(SIMULATED_DIMM)

#define RESERVED_DIMM_SIZE	16	/* only reserved 16 byte when DIMM is not available */

#else	/* SIMULATED_DIMM */

#define RESERVED_DIMM_SIZE	0x10000

typedef struct _DIMM_ARENA
{
	DIMMADDR	Offset;
	U32			Length;
} DIMM_ARENA;

#define DIMM_HEADER_SIGNATURE	0x4A42424AL	/* 'JBBJ' */


typedef struct _DIMM_HEADER
{
	U32			Signature;	/* DIMM_HEADER_SIGNATURE */
	U32			CheckSum;
	U32			Reserved[2];
	DIMM_ARENA	Arenas[COMP_TYPE_MAXIMUM];
} DIMM_HEADER;

BoOL DimmHeader_CheckValidity( DIMM_HEADER* pHeader );
void DimmHeader_Checksum( DIMM_HEADER* pHeader );

#endif	/* SIMULATED_DIMM */

#endif /* OSD_DIMM_H */
