/* platform related micros has been moved into makefile */
//#define _X8632B
//#define _32BPLATFORM

//#define _AMD64B
//#define _64BPLATFORM

#define _OS_LINUX
//#define AHCI
/*#define AHCI_INTEL*/
//#define T3
//#define ATI
#define _COMPILER_GCC_COMPATIBLE

#include "products.h"

/*
 * different compilers have different macro for debugging compile. We use
 * normalize VDEBUG. So please define VDEBUG properly according to your compiler
 */


#if defined( _DEBUG ) 
	#define VDEBUG	1
#else
	//#define VDEBUG	0
	#undef VDEBUG  /* change by sandy 20071227 for T3 debug mode */
#endif


#ifdef USE_STORPORT
#define STOR_USE_SCSI_ALIASES
#define FULLDUPLEX_STORPORT	/* If not defined, it'll run under half duplex. */
#endif
#define BUILD_AS_RAID_DRIVER

#if !defined(BUILD_AS_RAID_DRIVER)
	#define JBOD_MODE_ONLY
#else
	#undef JBOD_MODE_ONLY
	#define ENABLE_DM
	#define XH_PATROL
	#define ENABLE_TRANSACTION_LOG
#endif

// define USING_SIMPLE_CAM
#define TRANSLATE_VIR_PHY_BY_OSD

#define PBM_DO_HDMA


#if defined( USING_SIMPLE_CAM )
	#if defined( TRANSLATE_VIR_PHY_BY_OSD )
		#undef TRANSLATE_VIR_PHY_BY_OSD
	#endif
	#if defined( PBM_DO_HDMA )
		#undef PBM_DO_HDMA
	#endif
#endif

/* CAM specific configurations */
#if defined( USING_SIMPLE_CAM )
	#define NVRAM_SIZE			( 32 * 1024 )			/* 32K NVRAM by default */
	#define DIMM_SIZE			( 32 * 1024 * 1024 )	/* 32M DIMM by default */
#endif

#define CAM_MMIO

#define ENABLE_CONSOLE_IN_ENGINE
#define WMI_EVENT_USEWMILIB
#define SUPPORT_ENCLOSURE
#define SUPPORT_BATTERY
/* jeffgforsafte */
#define SUPPORT_SAFTE

//#define _WMI_     


//#define WMI_SUPPORT_EVENT_ONLY

#define USE_EXPORT

//#define DDF_INTEGRATED
#define V2MDD_INTEGRATED

//### move disk cache code to Physical disk
#define DISKCACHE_ON_PD
//#define CAM_SUPPORT_MASTERSLAVE
/*jeffgsx4100*/
/* SUPPORT_CHANNEL_RESET must be defined to support SX4100 */
#define SUPPORT_CHANNEL_RESET

/* 
 * define USE_DMDIMM_ONLY to test with DIMM version DM in driver. BIOS must define 
 * USE_DMDIMM_ONLY if ENABLE_DM is defined. 
 */
//#define USE_DMDIMM_ONLY
#define USE_CC

//#define SUPPORT_DIRTY_RECORD

#if VDEBUG
//#define CC_ENABLE_DEBUG_LOG_BUF
//#define WINDRV_INSTALL_BUGCHECK_CALLBACK
#endif

#define SORTED_TASK_QUEUE

#define CAM_SUPPORT_SYNCHRONIZED_SETTING

#if defined(OCTOPUSII)
//	#define NO_RAID5
	#undef SUPPORT_DIRTY_RECORD
	#undef SUPPORT_BATTERY	
	#undef ENABLE_TRANSACTION_LOG
	#undef TRANSLATE_VIR_PHY_BY_OSD
	#undef SORTED_TASK_QUEUE

	#undef CAM_SUPPORT_SYNCHRONIZED_SETTING
	
	#define SIMULATED_DIMM
	#define SUPPORT_ENCLOSURE
	#define SATA_HOTPLUG
	#define NVRAM_NOT_AVAILABLE
#endif

#if defined(NAPA_MARVELL)
//	#define NO_RAID5
	#undef SUPPORT_DIRTY_RECORD
	#undef SUPPORT_BATTERY	
	#undef ENABLE_TRANSACTION_LOG
	#undef TRANSLATE_VIR_PHY_BY_OSD
	#undef SORTED_TASK_QUEUE

	#define SIMULATED_DIMM
	#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	0x40
	#undef SUPPORT_ENCLOSURE
	#define SATA_HOTPLUG

	#define DISABLE_PBM
	#define NVRAM_NOT_AVAILABLE
	#define DISABLE_SMART_CHECKING
	#define DISABLE_JBOD
	#define DONT_USE_NAPA_CAM_ATATASK

	#define MAX_PORT_SUPPORT  8	

	#if VDEBUG
	#define SIMULATE_ATA_TIMEOUT
	#endif
	
	/* Configure Marvell Channel Driver */
	//#define CAM_DISABLE_QUEUE_COMMAND
	#ifndef CAM_DISABLE_QUEUE_COMMAND
	#define ALLOW_NCQ
	#endif

	#define ENABLE_BBM
	#undef SUPPORT_SAFTE

	#define CAM_CHECK_DEPENDENCY		/* Before sending request to Marvell, check whether there is overlapped request running. */
	#define STORE_TRACE					/* Store TRACE to the flash if necessary. */
	#undef ADJUST_MARVELL_PREAMPHASIS
#endif


#if defined(T3)

#if defined(T3_MSI)
	#define NO_RAID5
#endif
#if !defined(NO_RAID5)
//	#define R5_MAX_ACCESS_SIZE		0x20	/* MUST define if stripeblocksize > 32 and DIMM is limited */
#endif
//	#define USE_STATIC_DATA_FOR_COMPONENT_EXTENSIONS /*linux can't use*/
	#define DISABLE_PBM
	#if !defined(DISABLE_PBM)	
		#define Check_Sequence_Random
	#endif
//	#define Raid5WriteNotSegmentStripeBlockSize /* for HD speed up when no pbm */	

//	#define USE_MML_CC //have RAID5 undef
	#undef SUPPORT_BATTERY
//	#define SUPPORT_ENCLOSURE
//	#define SUPPORT_SAFTE
	
	#undef SUPPORT_DIRTY_RECORD
	#undef ENABLE_TRANSACTION_LOG
	#if !defined(USE_MML_CC)
		#undef TRANSLATE_VIR_PHY_BY_OSD  
	#endif
//	#undef SORTED_TASK_QUEUE
	#define ENGINE_USE_SYNC_FOR_BGINIT
	#define SIMULATED_DIMM
	#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	0x20	//32 sectors == 16K for engine DIMM request
	#define SATA_HOTPLUG
	#define NVRAM_NOT_AVAILABLE
//	#undef JBOD_MODE_ONLY

	#define XOR_HOST_MEM_CAPABLE
	#define DMA_HOST_TO_DISK_SUPPORTED

//	#define CAM_ATA_SRST_USING_TASK
	#define MAX_BLOCK_PER_DISK	2
	#define MAX_LU_PER_TARGET	MAX_BLOCK_PER_DISK

	#define CAM_ATAPI_SUPPORT
	#define ENGINE_SUPPORT_ATAPI

	#define ENGINE_SUPPORT_SAS_TAPE
	#define SUPPORT_SAS_TAPE
	#define BIOS_DETECT_SAS_TAPE

	//#define NEW_BGA_RATE_CONTROL_SCHEME

	//#define SUPPORT_2TERABYTE
	#define FORCE_ALLRAID_16K
//	#define SUPPORT_ALPE_CTRL
//	#define SUPPORT_PM
#if defined(SUPPORT_PM)
	#define MAX_PORT_SUPPORT		4
	#define MAX_DISK_SUPPORTED		8
#else
	#define MAX_PORT_SUPPORT		4
	#define MAX_DISK_SUPPORTED		4
#endif
//	#define SUPPORT_ENCLOSURE
//	#define SUPPORT_CCC
//	#define SUPPORT_PASSTHROUGH
//	#define SUPPORT_ICH6_BUG
	#define SUPPORT_T3
	#define SUPPORT_SAS
	#define ENGINE_SUPPORT_SCSIOP_MODE_SENSE_SELECT
	//#define ENGINE_SUPPORT_REPORT_LUNS
	#define LLReg2ResetSASPHY
	#define SUPPORT_FAULTLED

	#if defined(_OS_WINDOWS)//for Cam_CC
	//#if defined(SUPPORT_SAS)
	#define supportsaswrite
	#endif
	#define SUPPORT_BUZZER				//jordan

#if defined(T3_MSI)
	#define SUPPORT_MSI_ESATA			//jordan
#endif


#if !defined(SUPPORT_PM) && defined(SUPPORT_T3)
	#define SUPPORT_ENCLOSURE
	#define SUPPORT_SAFTE
#endif

#if defined(SUPPORT_T3)

    #define NCQ3GDIVE0 "HDT72252DLA380"
    #define NCQ3GDIVE1 "HDS728080PLA380"
    #define NCQ3GDIVE2 "Hitachi"
    #define NCQ3GDIVE3 ""
    #define NCQ3GDIVE4 ""
    #define MAX_NCQ3GDRIVES_DISABLED 3

	#define T3_IoMeter_WorkAround
	#define T3_IoMeter_WorkAround1

//	#define T3_WorkAround
//	#define T3_WorkAround1
//	#define T3_WorkAround2
//	#define T3_WorkAround3
//	#define T3_WorkAround4
//	#define T3_WorkAround5
	#define T3_WorkAround6
//	#define T3_WorkAround7
//	#define T3_WorkAround8
//	#define T3_WorkAround9
	#define T3_WorkAround10
//	#define T3_WorkAround11
//	#define T3_WorkAround12
//	#define T3_WorkAround13
	
//	#define SASSATA_HotPlug_Debug //T3_WorkAround7
//	#define SAS_BYTECOUNTERROR_Debug //T3_WorkAround9
//	#define Hotplug_WatingDeviceReady_Wait10S //T3_WorkAround12 T3_WorkAround13	
	
#if defined(T3_WorkAround)//AHCI_BUG_TEST
//	#define ASIC_Debug_Wait1S
//	#define ASIC_Debug_15G
//	#define ASIC_Debug_Wait5S
//	#define ASIC_Debug_SATAPI
#if defined(SUPPORT_PM)
	#define ASIC_Debug_PM
#endif
//#if !defined(ASIC_Debug_15G)
//	#define ASIC_Debug_30G
//#endif
#if defined(SUPPORT_CCC)
	#define ASIC_Debug_CCC
#endif
#endif
#endif

#endif


#if defined(AHCI_INTEL)

//	#define NO_RAID5
//	#define USE_STATIC_DATA_FOR_COMPONENT_EXTENSIONS
	#define DISABLE_PBM
#if !defined(DISABLE_PBM)	
	#define Check_Sequence_Random
#endif
//	#define USE_MML_CC
	#undef SUPPORT_BATTERY
	#undef SUPPORT_ENCLOSURE
	#undef SUPPORT_SAFTE
	
	#undef SUPPORT_DIRTY_RECORD
	#undef ENABLE_TRANSACTION_LOG
#if !defined(USE_MML_CC)
	#undef TRANSLATE_VIR_PHY_BY_OSD  
#endif
//	#undef SORTED_TASK_QUEUE

	#define SIMULATED_DIMM
	#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	0x20	//32 sectors == 16K for engine DIMM request
	#define SATA_HOTPLUG
	#define NVRAM_NOT_AVAILABLE
//	#undef JBOD_MODE_ONLY

	#if !defined(NO_RAID5) 
	#define R5_MAX_ACCESS_SIZE		MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	/* MUST define if stripeblocksize > 32 and DIMM is limited */
	#endif

	#define XOR_HOST_MEM_CAPABLE
	#define DMA_HOST_TO_DISK_SUPPORTED

//	#define CAM_ATA_SRST_USING_TASK
	#define MAX_BLOCK_PER_DISK	2
	#define MAX_LU_PER_TARGET	MAX_BLOCK_PER_DISK

	//#define MAX_PORT_SUPPORT	4
	//#define MAX_DISK_SUPPORTED	8

	#define CAM_ATAPI_SUPPORT
	#define ENGINE_SUPPORT_ATAPI
	//#define SUPPORT_2TERABYTE
	#define FORCE_ALLRAID_16K

	#define ENGINE_ENABLE_SPAN
	
	#define SUPPORT_ALPE_CTRL
	#define SUPPORT_PM
	
	#if defined(CAM_ATAPI_SUPPORT)
	#define SUPPORT_ASYNCHRONOUS_NOTIFICATION
	#endif	

	#if defined(SUPPORT_PM)
	#define MAX_PORT_SUPPORT	6
	#define MAX_DISK_SUPPORTED	8
	#else
	#define MAX_PORT_SUPPORT	6
	#define MAX_DISK_SUPPORTED	6
	#endif
	
	#define SUPPORT_CCC
	#define SUPPORT_CCC_SETTING
	#define SUPPORT_NCQDiskIDSetting
	#define SUPPORT_PASSTHROUGH

	//#define SUPPORT_T3
	//#define T3_WorkRun
	//#define SUPPORT_SAS


#if !defined(SUPPORT_PM) && defined(SUPPORT_T3)
//	#define SUPPORT_ENCLOSURE
//	#define SUPPORT_SAFTE
#endif

#if defined(SUPPORT_T3)
	#define T3_WorkAround
	#define SASSATA_HotPlug_Debug
	#define SAS_BYTECOUNTERROR_Debug
	#define Hotplug_WatingDeviceReady_Wait10S
#if defined(T3_WorkAround)//AHCI_BUG_TEST
	//#define ASIC_Debug_15G
	//#define ASIC_Debug_Wait1S
//	#define ASIC_Debug_SATAPI
#if defined(SUPPORT_PM)&&defined(SUPPORT_T3)
	#define ASIC_Debug_PM
#endif
//#if !defined(ASIC_Debug_15G)
//	#define ASIC_Debug_30G
//#endif
#if defined(SUPPORT_CCC)&&defined(SUPPORT_T3)
	#define ASIC_Debug_CCC
#endif
#endif
#endif

#endif


#if defined(ATI)
	#define SUPPORT_BLUERAY
//	#define NO_RAID5
//	#define USE_STATIC_DATA_FOR_COMPONENT_EXTENSIONS
	#define DISABLE_PBM
	//#define RESERVED_MEMORY
	
	#define DISABLE_FLUSH

	#define ENABLE_BACKUP

//	#define USE_MML_CC
#if !defined(DISABLE_PBM)
	#define Check_Sequence_Random
#if	defined(RESERVED_MEMORY)
	#define RESERVED_MEMORY_CC
#endif
#endif
	#undef SUPPORT_BATTERY
	#undef SUPPORT_ENCLOSURE
	#undef SUPPORT_SAFTE
	
	#undef SUPPORT_DIRTY_RECORD
	#undef ENABLE_TRANSACTION_LOG
#if !defined(USE_MML_CC)
	#undef TRANSLATE_VIR_PHY_BY_OSD  
#endif
//	#undef SORTED_TASK_QUEUE
	#define ENGINE_USE_SYNC_FOR_BGINIT
	#define SIMULATED_DIMM
	#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	0x20	//32 sectors == 16K for engine DIMM request
	//#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	0x80
#if !defined(NO_RAID5)
	//#define R5_MAX_ACCESS_SIZE		0x20	/* MUST define if stripeblocksize > 32 and DIMM is limited */
//#if !defined(NO_RAID5) && !defined(RESERVED_MEMORY)
#if !defined(RESERVED_MEMORY)
	#undef MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR
	//#define R5_MAX_ACCESS_SIZE		0x20	/* MUST define if stripeblocksize > 32 and DIMM is limited */
	#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	0x20
#endif
	#define R5_MAX_ACCESS_SIZE		MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	/* MUST define if stripeblocksize > 32 and DIMM is limited */
#endif
	#define SATA_HOTPLUG
	#define NVRAM_NOT_AVAILABLE
//	#undef JBOD_MODE_ONLY

	#define XOR_HOST_MEM_CAPABLE
	#define DMA_HOST_TO_DISK_SUPPORTED

//	#define CAM_ATA_SRST_USING_TASK
	#define MAX_BLOCK_PER_DISK	2
	#define MAX_LU_PER_TARGET	MAX_BLOCK_PER_DISK

	#define CAM_ATAPI_SUPPORT
	#define ENGINE_SUPPORT_ATAPI
	//#define SUPPORT_2TERABYTE
	#define FORCE_R1_64K
	#define ENGINE_ENABLE_SPAN
		
//	#define SUPPORT_ICH6_BUG

	#define SUPPORT_ALPE_CTRL
	#define SUPPORT_PM
	
	#if defined(CAM_ATAPI_SUPPORT)
	#define SUPPORT_ASYNCHRONOUS_NOTIFICATION
	#endif

#if defined(SUPPORT_PM)
	#define MAX_PORT_SUPPORT		6
	#define MAX_DISK_SUPPORTED		10
#else
	#define MAX_PORT_SUPPORT		6
	#define MAX_DISK_SUPPORTED		6
#endif

	#define SUPPORT_CCC
	#define SUPPORT_CCC_SETTING
	#define SUPPORT_NCQDiskIDSetting
	#define SUPPORT_PASSTHROUGH
#endif


#if defined(NAPA_FPGA)
    #define NAPA_ASIC
    #define CAM_SUPPORT_HW_TRIGGER
  #if VDEBUG
//		#define OSD_CHECK_READ_DATA
	#endif
	 
	/* TODO */
	#undef SUPPORT_DIRTY_RECORD

    	//#undef CAM_SUPPORT_SYNCHRONIZED_SETTING
    	
	// current ASIC has bug to handle packets/PRD tables in host memory.
	//#define CAM_USE_HOSTMEM_FOR_PACKETS
	
	#define CAM_NAPA_DEDICATED_XOR_HDMA

	#define ALLOW_ARRAY_ON_SAME_PD	/* DEBUGGING ONLY */

	#define CAM_SATA_INT_WORKAROUND

	#define CAM_SATA_BISTTESTDATA_ENABLE

	#define XOR_HOST_MEM_CAPABLE
	#define DMA_HOST_TO_DISK_SUPPORTED

	#define	ENGINE_ROUND_CRITICAL_R5_ACCESS

       #define MAX_PORT_SUPPORT	8

	//#define NAPA_FPGA_ONEXOR

	//#define SIMULATED_DIMM
	//#define DISABLE_PBM
	
	#ifdef SIMULATED_DIMM
	//	#define DISABLE_PBM
		#define NVRAM_NOT_AVAILABLE
		#define NAPA_DIMM_BASE 0x00000001
	#else
		#define NAPA_DIMM_BASE 0x80000000
	#endif
	/* NVRAM not work with current NAPA controller, disable it temporarily */
	//#define NVRAM_NOT_AVAILABLE


	#undef SUPPORT_BATTERY	
	//#undef ENABLE_TRANSACTION_LOG
	//#undef TRANSLATE_VIR_PHY_BY_OSD
	//#undef SORTED_TASK_QUEUE

	//#define SUPPORT_PM
#ifdef BIOS_BUILD
	#undef SUPPORT_ENCLOSURE
    	#undef CAM_MMIO
#endif
	//#undef SUPPORT_ENCLOSURE
	#define SATA_HOTPLUG
    	#define DDR_FIFO_WORKAROUND
    	#define CAM_SUPPORT_TWOBOX
      	#define CAM_USE_64BITSG
      	
  #define ENGINE_RESERVE_DIMM
	/* ENGINE_RESERVED_DIMM_SIZE must be defined also if ENGINE_RESERVE_DIMM defined. */
	#define ENGINE_RESERVED_DIMM_SIZE	(64*1024)

#if VDEBUG
//	#define CAM_PERFORM_XOR_TEST
//	#define CAM_ENABLE_TASK_TRACE
#endif  
      	
#endif

/* 
 * BE CAUTION: CHECK_DMA_DIMM_AREA should never be defined in either checked 
 * or free driver build. Define it only if you know what will happen with it.
 * It is for debugging only!!!
 */
/*#define CHECK_DMA_DIMM_AREA*/

/*
 * OSD_CHECK_REQ_TIMEOUT is used to debug os request timeout
 */
//#if defined(VDEBUG)
//#define OSD_CHECK_REQ_TIMEOUT
//#endif

#if 0
#define MINI_AUX_BUF_BLOCK_SIZE_IN_SECTOR	8
#endif

//#if !defined(JBOD_MODE_ONLY) && (MAX_LU_PER_TARGET > 1)
//#define ENGINE_SUPPORT_REPORT_LUNS	/* new feature, not released yet */
//#endif

#define ENGINE_SUPPORT_SCSIOP_STARTSTOP_UNIT

#if defined(ATI) || defined(AHCI_INTEL)			//change define for AMD(ATI) by tammy
#if defined(ENGINE_SUPPORT_SCSIOP_STARTSTOP_UNIT)		//by tammy
#define ENGINE_SCSIOP_STARTSTOP_UNIT_DONT_SLEEP
#endif
#endif

//#define ENGINE_SUPPORT_SCSIOP_RESERVE_RELEASE
// Engine still has problem to support EVPD inquiry, so disable it now.
//#define ENGINE_SUPPORT_SCSIOP_INQUIRY_EVPD
//#define ENGINE_SUPPORT_SCSIOP_MODE_SENSE_SELECT
#define ENGINE_SUPPORT_LARGE_LU
//#define ENGINE_SUPPORT_REPORT_LUNS

#define USE_SEPARATED_ARRAY_REQ_QUEUE

#if defined(VDEBUG)
#define T3_DEBUG
#endif
/*add sandy 20071224 for T3 debug mode*/


