#ifndef OSD_CONS_h
#define OSD_CONS_h

/* driver version related definitions */	
#ifndef KERNEL_VERSION
#define KERNEL_VERSION(x,y,z) (((x)<<16)+((y)<<8)+(z))
#endif

#if defined(ATI)
#define VERSION_MAJOR			  	3	
#define VERSION_MINOR				1		
#define VERSION_OEMCODE				1540
#define VERSION_BUILDNUM			10	
#define FASTTRAK_DRIVER_VERSION "3.1.1540.10"

#else
#define VERSION_MAJOR				1
#define VERSION_MINOR				1
#define VERSION_OEMCODE				0
#define VERSION_BUILDNUM			12

//#define FASTTRAK_DRIVER_VERSION "2.5.1540.17"
#define FASTTRAK_DRIVER_VERSION "1.1.0.12"
#endif

#define FASTTRAK_DRIVER_DATE	"(Feb 14, 2008)"

/* controller related definitions */
#if !defined(MAX_ADAPTORS)
#define MAX_ADAPTORS	 5
#endif

#if defined(OCTOPUSII)

	#define MAX_ADAPTER_TYPE			3	

#elif defined(NAPA_MARVELL)

	#define MAX_ADAPTER_TYPE			1		

#elif defined(NAPA_FPGA)

	#define MAX_ADAPTER_TYPE			7		

//#elif defined(AHCI_INTEL)

	//#define MAX_ADAPTER_TYPE			8
		
#elif defined(SUPPORT_T3)

        #define MAX_ADAPTER_TYPE                        8

#elif defined(ATI)

        #define MAX_ADAPTER_TYPE                        8

#else
	/* SX4/4000/4100*/
	#define MAX_ADAPTER_TYPE			4		

#endif


#define PCI_REVISION_ID_ADDRESS			8
#define PCI_VENDOR_ID_FASTTRAK_PROMISE 	0x105a
#define PCI_DEVICE_ID_SX4000				0x6621
#define PCI_DEVICE_ID_SX4					0x6622
#define PCI_DEVICE_ID_SX4100				0x6624
#define PCI_DEVICE_ID_NAPA					0x6300

#define VEN_DEV_SX4000						0x105A6621
#define SUB_VEN_DEV_SX4000					VEN_DEV_SX4000
#define VEN_DEV_SX4							0x105A6622
#define SUB_VEN_DEV_SX4					VEN_DEV_SX4
#define VEN_DEV_SX4100						0x105A6624
#define SUB_VEN_DEV_SX4100					VEN_DEV_SX4100
#define VEN_DEV_NAPA						0x105A6300
#define SUB_VEN_DEV_NAPA					VEN_DEV_NAPA

#define OSDM_MAX_TARGET_NUM			(MAX_ARRAY_SUPPORTED+1)
#define OSDM_MAX_LUN_PER_TARGET		1

#define CAN_QUEUE					32 
//#define CAN_QUEUE                                       1
#define FASTTRAK_MAX_SG 				24	/* for ASIC workaround, MAX_SG < 32, 20070531  */
#define MAX_SG 							FASTTRAK_MAX_SG
#define MAX_TIMER_QUEUE 				32


/* IOCTL related definitions */
//#define FASTTRAK_DEV_NAME           "t3sas"
//#define FASTTRAK_DEV_NAME           "ahci_ati"
#define FASTTRAK_IOCTL_SIGNATURE1   0x54534146
#define FASTTRAK_IOCTL_SIGNATURE2   0x4b415254

#define MAX_DATA_BUFFER_COUNT 2

#define CONSOLEDEVICE_TARGETID OSDM_MAX_TARGET_NUM-1
#define SRB_NO_ERROR 1
#define SRB_SELECTION_TIMEOUT        0x0A
#define SRB_SEE_SENSE 0x84

	/*SCSI Passthrough API Related	*/
#define ocmdEnclosure	0x0
#define ocmdBattery		0x1
#define ocmdGetAdapter	0x5
	/* For ocmdEnclosure: Enclosure Control */
#define API_ENCLOSURE_SUB_GETENCLOSURE		0x01
#define API_ENCLOSURE_SUB_GETSENSOR			0x02
#define API_ENCLOSURE_SUB_LEDLOCATE			0x03
#define API_ENCLOSURE_SUB_MAPDISKID			0x04


/* Whenever there is a component started, it'll call the OSD_ComponentStarted function. */
#define COMP_START_STATUS_SUCCESS	1

#endif /* OSD_CONS_H */

