#if !defined(OSD_IOCTL_H)
#define OSD_IOCTL_H


/* SCSI pass through simulation use */
#define SPT_SENSE_LENGTH 		32

#if defined(__KERNEL__)

#define PULONG	unsigned int *
#define ULONG unsigned int
#define PUCHAR unsigned char *
#define PUSHORT unsigned short *
#define USHORT unsigned short 
#define UCHAR unsigned char


#endif

/* Using ULONG instead of U32 for the sake of the API. */
typedef struct tagIOCTL_DRIVERVERSION_FRAME
{
	U32 Major;
	U32 Minor;
	U32 Oem;
	U32 BuildNo;
	U32 Signature[2];
	U32 ConsoleID;
	U8 HostNumber;
	U8 bReserved[2];
	U32 Reserved[3];
} IOCTL_DRIVERVERSION_FRAME, *PIOCTL_DRIVERVERSION_FRAME;

/* Controller Page */

typedef struct	_VERSION_INFO
{
	U32 VerMajor;
	U32 VerMinor;
	U32 VerOEM;
	U32 VerBuild;
	U32	wReserved[2];
}
VERSION_INFO, *PVERSION_INFO;

typedef struct _APIFRAME_ADAPTER_INFORMATION {
	U32 BaseAddress[BASE_ADDRESS_MAX_NUM];
	U32 ExpansionROMAddress;

	VERSION_INFO DriverVersion;
	VERSION_INFO BIOSVersion;
	
	U32 SystemIoBusNumber;
	U32 SlotNumber;
	U32 InterruptLevel;
	U32 InterruptVector;
	U32 VenDevID;				/* Vendor (105A) and Device ID (xxxx) */
	U32 SubVenDevID;			/* Sub-Vendor (105A) and Sub-Device ID (xxxx) */

	U32 DIMMSize;				/* size in MB */
	U8 DIMMType;				/* see DIMM_TYPE_xxx */
	U8 bReserved[3];
	
	U32 ChannelNumber;
	U32 Reserved;
} APIFRAME_ADAPTER_INFORMATION, *PAPIFRAME_ADAPTER_INFORMATION;

typedef struct _SRB_IO_CONTROL{
	U32 	HeaderLength;
	U8	Signature[8];
	U32	Timeout;
	U32	ControlCode;
	U32	ReturnCode;
	U32	Length;	
}SRB_IO_CONTROL, *PSRB_IO_CONTROL;

typedef struct _MY_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER {
	U8 SrbStatus;
    	U8 ScsiStatus;
    	U8 TargetId;
    	U8 Lun;
    	U8 CdbLength;
    	U8 SenseInfoLength;
    	U32 DataTransferLength;
    	U8 Cdb[16];
    	U8 SenseBuffer[SPT_SENSE_LENGTH];
}MY_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER, *PMY_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER;


#define MAX_DATA_BUFFER_SIZE 4096 - sizeof(SRB_IO_CONTROL) - sizeof(MY_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER)

struct PASS_THRU_IOBUF{
	SRB_IO_CONTROL SrbCtrl;
	MY_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER MySptd;
	U8 DataBuffer[MAX_DATA_BUFFER_SIZE];
}; 

/* IOCTL Code */
#define IOCTL_FASTTRAK_GETVERSION           0x00000001
/* Linux SCSI Passthru command wrap use, old IOCTL scheme use only */
#define IOCTL_FASTTRAK_PASSTHRU         _IOWR(0, 1, struct PASS_THRU_IOBUF)  

typedef struct _APIFRAME_SENSOR
{
	U8 SensorType;
	U8 Reserved[3];
	U32	SensorValue;
} APIFRAME_SENSOR, FAR* PAPIFRAME_SENSOR;

typedef struct _APIFRAME_SENSOR_INFORMATION {
	APIFRAME_SENSOR Sensor[CAM_MAX_SENSOR_PER_ENCLOSURE];
} APIFRAME_SENSOR_INFORMATION, *PAPIFRAME_SENSOR_INFORMATION;

/* Others */
typedef struct _APIFRAME_U32 {
	U32 Value;
} APIFRAME_U32, *PAPIFRAME_U32;

	
#endif /* OSD_IOCTL_H */
