/*** Copyright Notice *******************************************************

 *

 * Copyright (C) 1998 - 2003 Promise Technology, Inc.

 * All Rights Reserved.

 *

 * This software is confidential and proprietary property of

 * Promise Technology, Inc.

 * 2F, #30, Industry East Road, IX, Science-Based Industrial Park

 * HsinChu 

 * Taiwan

 *

 * Promise Technology, Inc.

 * 1745 McCandless Drive

 * Milpitas, CA 95035

 * U.S.A.

 *

 * Promise Technology (Shanghai), Ltd.

 * 1189 Wuding West Road, Suite 508

 * Shanghai 200042

 * China

 *

 *

 ***************************************************************************/

#include "osd_inc.h"

//MODULE_AUTHOR("Sandy Tan");
//MODULE_LICENSE("GPL");

/* global var definitions */
struct proc_dir_entry proc_scsi_t3 = {		
   0,					
   8,					
   FASTTRAK_DEV_NAME,				// name of directory entry
   S_IFDIR | S_IRUGO | S_IXUGO,	
   2,				
};


static wait_queue_head_t Wait0;

int	NumAdapter=0;
unsigned char * t3_hostp[MAX_ADAPTORS]={0};
static unsigned int    gVenID[MAX_ADAPTER_TYPE] = {
 #if defined(OCTOPUSII)
          0x105a
	, 0x105a
	, 0x105a
#elif defined(NAPA_MARVELL)
	  0x11ab
#elif defined(NAPA_FPGA)
	/* SX4300/8300*/
	  0x105a
	, 0x105a
	, 0x105a
	, 0x105a
	, 0x105a
	, 0x105a
	, 0x105a
	, 0x105a
/*#elif defined(AHCI_INTEL)
	  0x8086
	, 0x8086
	, 0x8086
	, 0x8086
	, 0x8086
	, 0x1002
	, 0x1002
	, 0x8086*/
#elif defined(SUPPORT_T3)
          0x105a
        , 0x105a
        , 0x105a
        , 0x105a
        , 0x105a
        , 0x105a
        , 0x105a
        , 0x105a
#elif defined(ATI)
          0x1002
        , 0x1002
        , 0x1002
        , 0x1002
        , 0x1002
        , 0x1002
        , 0x8086   /* ICH-8R */
        , 0x1002  /*Moray RS485 (NB) */
#else
	/* SX4/4000/4100*/
	  0x105a
	, 0x105a
	, 0x105a
	, 0x105a
#endif
  };
static unsigned int   gDevID[MAX_ADAPTER_TYPE] = {
#if defined(OCTOPUSII)
	  0x3571
	, 0x3519
	, 0x3574
#elif defined(NAPA_MARVELL)
	  0x6081
#elif defined(NAPA_FPGA)
	/* SX4300/8300*/
	  0x6300
	, 0x6301
	, 0x6302
	, 0x6303
	, 0x6304
	, 0x6305
	, 0x6306
	, 0x6307
/*#elif defined(AHCI_INTEL)
	  0x2652
	, 0x2653
	, 0x27c1
	, 0x27c5
	, 0x27c3
	, 0x4380
	, 0x4381
	, 0x2652*/
#elif defined(SUPPORT_T3)
	  0x3775
	, 0x3776
	, 0x3777
	, 0x3778
	, 0x3F17
	, 0x3F18
	, 0x3F19
	, 0x3F20
#elif defined(ATI)
          0x4380
        , 0x4381
        , 0x4382
        , 0x4391
        , 0x4392
        , 0x4393
        , 0x2822   /* ICH-8R */
        , 0x5059  /*Moray RS485 (NB) */

#else
	/* SX4/4000/4100*/
	  0x6621
	, 0x6622
	, 0x6623
	, 0x6624
#endif
};
unsigned long 	   gVenDevID[MAX_ADAPTER_TYPE] = {
#if defined(OCTOPUSII)
	  0x105a3571
	, 0x105a3519
	, 0x105a3574
#elif defined(NAPA_MARVELL)
	  0x11ab6081
#elif defined(NAPA_FPGA)
	/* SX4300/8300*/
	  0x105a6300
	, 0x105a6301
	, 0x105a6302
	, 0x105a6303
	, 0x105a6304
	, 0x105a6305
	, 0x105a6306
	, 0x105a6307
/*#elif defined(AHCI_INTEL)
	  0x80862652
	, 0x80862653
	, 0x808627c1
	, 0x808627c5
	, 0x808627c3
	, 0x10024380
	, 0x10024381
	, 0x80862652*/
#elif defined(SUPPORT_T3)
	  0x105A3775
	, 0x105A3776
	, 0x105A3777
	, 0x105A3778 /* T3 2 ports */
	, 0x105A3F17
	, 0x105A3F18
	, 0x105A3F19
	, 0x105A3F20 /* T3 4 ports */

#elif defined(ATI)
          0x10024380
        , 0x10024381
        , 0x10024382
        , 0x10024391
        , 0x10024392
        , 0x10024393
        , 0x80862822   /* ICH-8R */
        , 0x10025059  /*Moray RS485 (NB) */

#else
	/* SX4/4000/4100*/
	  0x105a6621
	, 0x105a6622
	, 0x105a6623
	, 0x105a6624
#endif
};
unsigned long    gSubVenDevID[MAX_ADAPTER_TYPE] = {
#if defined(OCTOPUSII)
	  0x105a3571
	, 0x105a3519
	, 0x105a3574

#elif defined(NAPA_MARVELL)
	  0x11ab6081

#elif defined(NAPA_FPGA)
	/* SX4300/8300*/
	  0x105a6300
	, 0x105a6301
	, 0x105a6302
	, 0x105a6303
	, 0x105a6304
	, 0x105a6305
	, 0x105a6306
	, 0x105a6307

/*#elif defined(AHCI_INTEL)
	  0x80862652
	, 0x80862653
	, 0x808627c1
	, 0x808627c5
	, 0x808627c3
	, 0x10024380
	, 0x10024381
	//, 0x10432606  //AHCI
	, 0x10432604 //RAID */

#elif defined(SUPPORT_T3)
          0x105A3775
        , 0x105A3776
        , 0x105A3777
        , 0x105A3778 /* T3 2 ports */
        , 0x105A3F17
        , 0x105A3F18
        , 0x105A3F19
        , 0x105A3516 /* T3 4 ports */

#elif defined(ATI)
          0x10024380
        , 0x10024381
        , 0x10024382
        , 0x10024391
        , 0x10024392
        , 0x10024393
        , 0x80862822   /* ICH-8R */
        , 0x10025059  /*Moray RS485 (NB) */

#else

	/* SX4/4000/4100*/
	  0x105a6621
	, 0x105a6622
	, 0x105a6623
	, 0x105a6624

#endif
};

#define __t3_wait_event_timeout(wq, condition, ret)\
do {\
        DEFINE_WAIT(__wait);\
        for (;;) {\
                prepare_to_wait(&wq, &__wait, TASK_UNINTERRUPTIBLE);\
                if (condition)\
                        break;\
                ret = schedule_timeout(ret);\
                if (!ret)\
                        break;\
        }\
        finish_wait(&wq, &__wait);\
} while (0)
 

#define t3_wait_event_timeout(wq, condition, timeout)\
{\
	long __ret = timeout;\
	if (!(condition))\
		__t3_wait_event_timeout(wq, condition, __ret);\
	__ret;\
}
//add for the time-consuming problem that will lead to a system panic on T3 driver initial stage (20070103)


int gMajor;

	U32 g_JbodOnly = 0; // not jbod only (sandy)

BoOL gIsHibernation = FALSE;
unsigned long	MAX_CONCURRENT_IO = MAX_CONCURRENT_IO_DEFAULT;
#if VDEBUG
int gFlag,gFlagInt;
extern int gIoctlFlag;
#endif

extern struct file_operations t3_fops;	

int wrap_print(const char *fmt,...)
{	
	static char buf[100];
	va_list args;
	int i;
	va_start(args,fmt);
	i=vsprintf(buf,fmt,args);
	i=printk(buf);
//	i=printk(fmt,args);
	va_end(args);
	return i;
	
}

#if defined(ATI)

#if 0
void* wrap_memcpy(void* dest, const void* src, unsigned n)
{
	return memcpy(dest, src, n);
}
#endif

U32 g_Misc_CTL = 0;     //Fast boot for HP Laptop by tammy

#endif

unsigned long *wrap_P2V(void *paddr){	
	return phys_to_virt(paddr);
}

#if defined(ATI)
unsigned long *wrap_V2P(void *paddr){	
	return virt_to_phys(paddr);
}
#endif

spinlock_t      kmap_lock = SPIN_LOCK_UNLOCKED;

/* The number of KMAP_TYPEs are limited, we should be carefully when using it. 
*  Before we used KM_USER0/KM_USER1, but it seems conflicts w/ some other system code concurrently.
*  Also, some(all ?) r/w compare errors maybe caused by this issue...
*/ 
unsigned char *wrap_HIGHMAP_PAGE(void *paddr, int phase){
	unsigned char *page_addr;
	unsigned long flags;
	int idx, i;

	spin_lock_irqsave(&kmap_lock, flags);

	if(phase == 0){
		page_addr = kmap_atomic((struct page*)paddr, KM_SKB_SUNRPC_DATA);
	}else if(phase == 1){
		page_addr = kmap_atomic((struct page*)paddr, KM_SKB_DATA_SOFTIRQ);
	}else if(phase == 2){
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
		page_addr = kmap_atomic((struct page*)paddr, KM_NETDUMP);
#else
		page_addr = kmap_atomic((struct page*)paddr, KM_BIO_SRC_IRQ);
#endif
        }

	spin_unlock_irqrestore(&kmap_lock, flags);
	return page_addr;
}

unsigned char* wrap_HIGHMAP(unsigned char *vaddr, void *p_src){
	unsigned char *addr;
	addr = (vaddr + ((U32)p_src & ~PAGE_MASK));
	return addr;
}

void wrap_HIGHUNMAP_PAGE(void *page_addr, int phase){
	unsigned long flags;	
	int idx;

	spin_lock_irqsave(&kmap_lock, flags);
	if(phase == 0){
		kunmap_atomic(page_addr, KM_SKB_SUNRPC_DATA);
	}else if(phase == 1){
		kunmap_atomic(page_addr, KM_SKB_DATA_SOFTIRQ);
	}else if(phase == 2){
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
                kunmap_atomic(page_addr, KM_NETDUMP);
#else
		kunmap_atomic(page_addr, KM_BIO_SRC_IRQ);
#endif
        }

	spin_unlock_irqrestore(&kmap_lock, flags);
}
/* add by sandy 20061025 (for physical_2_virtual address on  raid5) */

void wrap_memcpyfromio(void* mmiobase, const void* buffer, unsigned long count)
{
	memcpy_fromio( (char *)buffer, (char *)mmiobase, count);
}

void wrap_memcpytoio(void* mmiobase, const void* buffer, unsigned long count)
{
	memcpy_toio( (char *)mmiobase, (char *)buffer, count);
}

U32 wrap_readl(void * mmiobase)
{
	return readl(mmiobase);
}

U16 wrap_readw(void * mmiobase)
{
	return readw(mmiobase);
}

U8 wrap_readb(void * mmiobase)
{
	return readb(mmiobase);
}

void wrap_writel(void* mmiobase, U32 data)
{
	writel(data, mmiobase);
	//readl(mmiobase);
}

void wrap_writew(void* mmiobase, U16 data)
{
	writew(data, mmiobase);
	//readw(mmiobase);
}

void wrap_writeb(void* mmiobase, U8 data)
{
	writeb(data, mmiobase);
	//readb(mmiobase);
}

unsigned char wrap_inb(int addr)
{
	return(inb(addr));
}
unsigned short wrap_inw(int addr)
{
	return(inw(addr));
}
unsigned int wrap_inl(int addr)
{
	return(inl(addr));
}

void wrap_outb(int addr, unsigned char b)
{
	outb(b,addr);
}

void wrap_outw(int addr, unsigned short b)
{
	outw(b,addr);
}

void wrap_outl(int addr, unsigned int b)
{
	outl(b,addr);
}

/* added for request head pool management */
void init_req_pool(bpOSD_COMP_EXTENSION p)
{
	int i;

	for(i=0; i<CAN_QUEUE; i++){
		if(CAN_QUEUE -1 == i){
			p->ReqHeadPool[i].next = NULL;
		}else{
			p->ReqHeadPool[i].next = &(p->ReqHeadPool[i+1]);
		}
	}

	p->pReqCurrent = p->ReqHeadPool;
}

PREQ_HEAD get_req_from_pool(bpOSD_COMP_EXTENSION p)
{	
	PREQ_HEAD pReq;

	RES_LOCK

	pReq = p->pReqCurrent;

	if(NULL == pReq){
		OSD_DPRINT( ("get_req_from_pool: pool is empty\n") );
		RES_UNLOCK
		return NULL;
	}	

	p->pReqCurrent = pReq->next;
	pReq->next = NULL;

	RES_UNLOCK

	memset(pReq, 0, sizeof(REQ_HEAD) );
	
	return pReq;
}

void put_req_to_pool(bpOSD_COMP_EXTENSION p, PREQ_HEAD pReq)
{
	RES_LOCK

	if(NULL == pReq){
		OSD_DPRINT( ("put_req_to_pool: intend to put NULL req to pool\n") );
		RES_UNLOCK
		return;
	}	

	pReq->next = p->pReqCurrent;
	p->pReqCurrent = pReq;

	RES_UNLOCK
}

#if defined(OSD_CHECK_REQ_TIMEOUT)
void GEN_CALLBACK OsdReqTimeoutChecker (
	IN bpVOID ComponentExtension,	/* request component extension */
	IN bpVOID Timer,				/* same as return value of OSD_RequestTimer */
	IN bpVOID Context				/* the context provided by requester */
)
{
	bpOSD_COMP_EXTENSION This = (bpOSD_COMP_EXTENSION) ComponentExtension;
	bpREQ	p_rq = (bpREQ) GenList_GetHead( &This->CurrentReqList );

	while( p_rq )
	{
		p_rq->Osd.tickCount++;
		if( p_rq->Osd.tickCount>=6 )
		{
			OSD_TRACE( ("WARNING: Request %p %x (%d, %x) timing out...\n", p_rq, p_rq->bCDB[0]
			, p_rq->Osd.tickCount, p_rq->Osd.flags) );
		}
		p_rq = (bpREQ) GenList_GetNext( &This->CurrentReqList, p_rq );
	}

	OSD_RequestTimer( This, SECOND_IN_TIMER, OsdReqTimeoutChecker, 0, 0);
}
#endif


//api32_call_drv64
#if defined (_64BPLATFORM) && (LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14))
int conversion_handler(unsigned int fd,unsigned cmd, unsigned long arg, struct file *file)
{
	void*		SrbBuffer = (void*)arg;
	mm_segment_t 	old_fs;	
	int		err;
		
	old_fs = get_fs();	
	set_fs(KERNEL_DS);  //tell kernel to accept arguments in kernel space 
	err = sys_ioctl(fd, cmd, (unsigned long)SrbBuffer);
	set_fs(old_fs);
	
	return err;
}
#endif
/* change #ifdef->#if defined and add && (LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14)), 
for SuSe 10.1(kernel 2.6.16.13-4) undefin, by sandy 20070111 */

void GEN_CALLBACK OsdInitTimeout (
	IN bpVOID ComponentExtension,	/* request component extension */
	IN bpVOID Timer,				/* same as return value of OSD_RequestTimer */
	IN bpVOID Context				/* the context provided by requester */
)
{
	bpOSD_COMP_EXTENSION This = (bpOSD_COMP_EXTENSION) ComponentExtension;
	
	if(This->init_status != NP_INIT_UNDERWAY)
		return;
	if(waitqueue_active(&(This->Init_Waitq))){
		This->init_status = NP_INIT_FAILED;
		wake_up(&(This->Init_Waitq) );
		}
}

/* function   : void t3_intr(int irq, void *dev_id, struct pt_regs *regs);
 * input        : Standard Parameters
 * output      : NONE
 * description  : interrupt handler
 */

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
static void t3_intr(int irq, void *dev_id, void *regs)
#else
static irqreturn_t t3_intr(int irq, void *dev_id, void *regs)
#endif
{	
	bpOSD_COMP_EXTENSION pOSDExtension = (bpOSD_COMP_EXTENSION)dev_id; 
	bpOSD_COMP_EXTENSION p;	
	LPVOID pCAMExtension;
	unsigned long smpflag;
	int i;
	
	if(!dev_id)
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)		
		return;
#else
		return (IRQ_NONE);
#endif

	for(i=0; i<MAX_ADAPTORS; i++){
		if(t3_hostp[i]){
			p=OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[i]);
			if(pOSDExtension == p )
			break;
		}	
	}	
	
	if(i>=MAX_ADAPTORS||pOSDExtension->irq != irq)
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)		
		return;
#else
		return (IRQ_NONE);
#endif
	
	DRIVER_LOCK(pOSDExtension->host,smpflag);
	//OSD_TRACE( ("before call interrupt handler\n") );
#if VDEBUG	
	gFlagInt = 1;
	if(gFlag)	
		OSD_DPRINT( ("Oh, My God, we will call CAM interrupt handler in queue command routine \n") );	
	if(gIoctlFlag)	
		OSD_DPRINT( ("Oh, My God, we will call CAM interrupt handler in IOCLT handle routine \n") );	
#endif
	
	pCAMExtension=OSD_GetComponentExtension(pOSDExtension, COMP_TYPE_CAM);
	if ( !CAM_CheckInterrupt(pCAMExtension) ){
		DRIVER_UNLOCK(pOSDExtension->host,smpflag);	
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)		
		return;
#else
		return (IRQ_NONE);
#endif
	}		

	// We have at least one interrupt.

	CAM_HandleInterrupt(pCAMExtension);
#if VDEBUG 
	gFlagInt = 0;
#endif
	//OSD_TRACE( ("after call interrupt handler \n") );
	DRIVER_UNLOCK(pOSDExtension->host,smpflag);	

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)		
		return (IRQ_HANDLED);
#endif
}

/* function   : int t3_proc_info(char *buffer, char **start, off_t offset,
			int length, int hostno, int func);
 * input        : Standard Parameters
 * output      : byte count printed
 * description  : PROC filesystem entry
 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
static int t3_proc_info(char *buffer, char **start, off_t offset,
			int length, int hostno, int func)
#else			
static int t3_proc_info(struct Scsi_Host *host, char *buffer, char **start, off_t offset,
			int length, int func)
#endif
{
	int len;

	*start = buffer;
	if (func == TRUE) {
		/*
		 * The user has done a write and wants us to take the
		 * data in the buffer and do something with it.
		 * proc_scsiwrite calls us with inout = 1
		 *
		 * Read data from buffer (writing to us) - NOT SUPPORTED
		 */
		return -EINVAL;
	}

	len = sprintf(buffer,"***** T3 Driver %s %s*****\n", FASTTRAK_DRIVER_VERSION, FASTTRAK_DRIVER_DATE);

	len += sprintf(buffer + len,"***** Copyright 2004 by Promise Technology, Inc.   *****\n\n");

	*(buffer + len) = '\0';
 
	*start = buffer + (offset );	/* Start of wanted data */
	len -= (offset );
	if(len > length) {
		len = length;
	} else if(len < 0){
		len = 0;
		**start = '\0';
	}
	return len;
}

/* function   : static int t3_abort(Scsi_Cmnd *cmd);
 * input        : cmd = SCSI command to be aborted
 * output      : SUCCESS
 * description  : SCSI command abort function
 */
static int t3_abort(Scsi_Cmnd *cmd)
{
	OSD_DPRINT( ("t3_abort: returning SCSI_ABORT_ERROR\n") );

   	return SUCCESS;
}

/* function   : static int t3_reset(Scsi_Cmnd *cmd, unsigned int reset_flags)
 * input        : Standard Parameters
 * output      : SUCCESS
 * description  : SCSI reset function
 */
static int t3_reset(Scsi_Cmnd *cmd)
{
	bpOSD_COMP_EXTENSION pOSDExtension=NULL;
	struct Scsi_Host *phost;
	int i;

	OSD_DPRINT( ("t3_reset: Enter reset function ! \n") );

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
 	phost = cmd->host;
#else
	phost = cmd->device->host;
#endif

	for(i = 0; i < MAX_ADAPTORS; i++){
		if(t3_hostp[i]){
			pOSDExtension=OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[i]);
			if(phost == pOSDExtension->host)
			break;
		}	
	}
	if(i >= MAX_ADAPTORS || !phost) {
    		return FAILED;
 	}

   	if( !OSD_IsLdrDump(0) )
	{
		CAM_ComponentReset( OSD_GetComponentExtension(pOSDExtension,COMP_TYPE_CAM) );
		Engine_ComponentReset( OSD_GetComponentExtension(pOSDExtension,COMP_TYPE_ENGINE) );
#if !defined(DISABLE_PBM)
		PBM_ComponentReset( OSD_GetComponentExtension(pOSDExtension,COMP_TYPE_PBM) );
#endif /*DISABLE_PBM*/
	}
   	
   	return SUCCESS;
}


char EndRequest(void *cmnd,void *fun,int result) 
{
   Scsi_Cmnd	     *cmd  = (Scsi_Cmnd *)cmnd ;
   void	(*fn)(Scsi_Cmnd *) = (void *)fun ;
   cmd->result = result ;
   
   fn(cmd);
   return(0);
}

void RAID_Return(void *sender,bpREQ request)
{
	REQ_HEAD *p;
   	Scsi_Cmnd 		*cmd ;// =request -> cmd ;
   	void		(*fn)(void *);// = request -> fn ;
   	int	result=0; 
	bpOSD_COMP_EXTENSION This = (bpOSD_COMP_EXTENSION)sender;

   	//assert( (request != NULL) );	

	p = (PREQ_HEAD)(request->pOriginalRequest);
	cmd = (Scsi_Cmnd *)(p->cmd);
	fn = p->fn;

	OSD_TRACE( ("RAID_Return: Req = 0x%p, SrbStatus =%x, ScsiStatus = %x, ReqType=%x\n", p, request->bAdapterStatus, request->bTargetStatus, p->ReqType) );
	#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
	if(cmd->cmnd[0] == READ_CAPACITY)
	{
		if(*(U32 *)scsi_sglist(cmd)==0xffffffff)
			((U8 *)scsi_sglist(cmd))[3] = 0xfe;
	}
	#endif
	
  	//need improved
  	switch(request->bAdapterStatus)
	{
		case SRB_NO_ERROR:
			result= DID_OK << 16;
			break;
		case SRB_SELECTION_TIMEOUT:
			result= DID_BAD_TARGET << 16;
			break;
		case SRB_SEE_SENSE:
			result= (DRIVER_SENSE << 24) | (DID_OK << 16) | (CHECK_CONDITION << 1) ;
			//wrap_print("	%x\n", result);
			break;
		default:
			result |= DID_ERROR << 16; 
			//printk("In default, cdb[0]=%x\n", cmd->cmnd[0]);
			break;
  	}

#if defined(OSD_CHECK_REQ_TIMEOUT)
	if( request->Osd.flags & OSD_REQ_F_QUEUED )
	{
		GenList_RemoveEntry( &This->CurrentReqList, request );
		request->Osd.flags = 0;
	}
#endif

	put_req_to_pool(This, p);
   	
	EndRequest(cmd,fn,result);
   		
   	return ;
}

void
prepare_sg_table2(Scsi_Cmnd* cmd, REQ_HEAD* pReq, struct pci_dev *pDev)
{
	struct scatterlist *sg; 
	dma_addr_t dma_handle;
	int us;
	
	if (scsi_sg_count(cmd)){
		sg = (struct scatterlist *) scsi_sglist(cmd);
		pReq->SgTable.SGCount = (U16)pci_map_sg(pDev,sg,scsi_sg_count(cmd),scsi_to_pci_dma_dir(cmd->sc_data_direction));

		for (us = 0; us < pReq->SgTable.SGCount ; us++,sg++){
      			pReq->SgTable.table[us].Count  = (U32)sg_dma_len(sg);
      			pReq->SgTable.table[us].StartAddress.Value = cpu_to_le64(sg_dma_address(sg));
	
			pReq->SgTable.table[us].CtrlFlag = SG_CF_64B | SG_CF_HOST;
    		}
			pReq->SgTable.table[--us].CtrlFlag |= SG_CF_EOT;
			
	}else{
#if defined(CONFIG_X86_64)
#if defined(CONFIG_DISCONTIGMEM) && (LINUX_VERSION_CODE>=KERNEL_VERSION(2,4,18) )
		dma_handle = pci_map_page(pDev,virt_to_page(scsi_sglist(cmd)),((unsigned long)scsi_sglist(cmd) & ~PAGE_MASK),scsi_bufflen(cmd),scsi_to_pci_dma_dir(cmd->sc_data_direction));
#else
		dma_handle = pci_map_single(pDev,
						(scsi_sglist(cmd)),
						scsi_bufflen(cmd),
						scsi_to_pci_dma_dir(cmd->sc_data_direction) );
#endif
#else
#if LINUX_VERSION_CODE>=KERNEL_VERSION(2,4,18) 
	  	dma_handle = pci_map_page(pDev,virt_to_page(scsi_sglist(cmd)),((unsigned long)scsi_sglist(cmd) & ~PAGE_MASK),scsi_bufflen(cmd),scsi_to_pci_dma_dir(cmd->sc_data_direction));
 #else
 		dma_handle = pci_map_single(pDev,
						(scsi_sglist(cmd)),
						scsi_bufflen(cmd),
						scsi_to_pci_dma_dir(cmd->sc_data_direction) );
#endif
#endif
 		  pReq->SgTable.SGCount = cpu_to_le16(1);

		 pReq->SgTable.table[0].StartAddress.Value = cpu_to_le64(dma_handle);

		 pReq->SgTable.table[0].Count   = cpu_to_le32((U32) scsi_bufflen(cmd));
		 pReq->SgTable.table[0].CtrlFlag = SG_CF_EOT|SG_CF_64B | SG_CF_HOST;
 
		  }
		
  	pReq->req.pSgTable = &pReq->SgTable; 
  		
}
void RAID_Return2(void *sender,bpREQ request)
{
	REQ_HEAD *p;
   	Scsi_Cmnd 		*cmd ;// =request -> cmd ;
   	void		(*fn)(void *);// = request -> fn ;
   	int	result=0; 
	bpOSD_COMP_EXTENSION This = (bpOSD_COMP_EXTENSION)sender;

   	//assert( (request != NULL) );	

	p = (PREQ_HEAD)(request->pOriginalRequest);
	cmd = (Scsi_Cmnd *)(p->cmd);
	fn = p->fn;

	OSD_TRACE( ("RAID_Return: Req = 0x%p, SrbStatus =%x, ScsiStatus = %x, ReqType=%x\n", p, request->bAdapterStatus, request->bTargetStatus, p->ReqType) );
		
  	//need improved
  	switch(request->bAdapterStatus)
	{
		case SRB_NO_ERROR:
			result= DID_OK << 16;
			break;
		case SRB_SELECTION_TIMEOUT:
			result= DID_BAD_TARGET << 16;
			break;
		case SRB_SEE_SENSE:
			result= (DRIVER_SENSE << 24) | (DID_OK << 16) | (CHECK_CONDITION << 1) ;
			break;
		default:
			result |= DID_ERROR << 16; 
			break;
  	}

#if defined(OSD_CHECK_REQ_TIMEOUT)
	if( request->Osd.flags & OSD_REQ_F_QUEUED )
	{
		GenList_RemoveEntry( &This->CurrentReqList, request );
		request->Osd.flags = 0;
	}
#endif

	put_req_to_pool(This, p);
   	
	EndRequest(cmd,fn,result);
   		
   	return ;
}

void
prepare_sg_table(Scsi_Cmnd* cmd, REQ_HEAD* pReq, struct pci_dev *pDev)
{
	struct scatterlist *sg; 
	dma_addr_t dma_handle;
	int us;
	
	if (scsi_sg_count(cmd)){
		sg = (struct scatterlist *) scsi_sglist(cmd);
		pReq->SgTable.SGCount = (U16)pci_map_sg(pDev,sg,scsi_sg_count(cmd),scsi_to_pci_dma_dir(cmd->sc_data_direction));

		for (us = 0; us < pReq->SgTable.SGCount ; us++,sg++){
      			pReq->SgTable.table[us].Count  = (U32)sg_dma_len(sg);
      				
#if defined(CONFIG_HIGHMEM64G) || defined(CONFIG_X86_64)
			//pReq->SgTable.table[us].StartAddress.Value = sg_dma_address(sg);
			pReq->SgTable.table[us].StartAddress.Value = cpu_to_le64(sg_dma_address(sg));
			//printk("StartAddress = %p\n", pReq->SgTable.table[us].StartAddress.Value);
#else
		      	pReq->SgTable.table[us].StartAddress.u.Low = (U32)sg_dma_address(sg); 
#endif

                        OSD_DPRINT( ("SG Entry %d Address %p.\n", us, pReq->SgTable.table[us].StartAddress.Value) );
			pReq->SgTable.table[us].CtrlFlag = SG_CF_64B | SG_CF_HOST;
			
			//pReq->SgTable.table[us].Page = sg->page; //add by sandy 20061025
			#if LINUX_VERSION_CODE <  KERNEL_VERSION(2,5,0)
			// Kernel 2.4 will leave it empty if address in lowmem.
				if(!sg->page)
	                                pReq->SgTable.table[us].Page = virt_to_page(sg->address);
				else
					pReq->SgTable.table[us].Page = sg_page(sg);
                        #else
                                pReq->SgTable.table[us].Page = sg_page(sg);
				//pReq->SgTable.table[us].offset = sg->offset; //add by sandy 20071225
                        #endif
			//add by sandy 20070111
    		}
			pReq->SgTable.table[--us].CtrlFlag |= SG_CF_EOT;
			
	}else{
		
#if LINUX_VERSION_CODE>=KERNEL_VERSION(2,4,18)
	  	dma_handle = pci_map_page(pDev,virt_to_page(scsi_sglist(cmd)),((unsigned long)scsi_sglist(cmd) & ~PAGE_MASK),scsi_bufflen(cmd),scsi_to_pci_dma_dir(cmd->sc_data_direction));
 #else
 		dma_handle = pci_map_single(pDev,
						(scsi_sglist(cmd)),
						scsi_bufflen(cmd),
						scsi_to_pci_dma_dir(cmd->sc_data_direction) );
#endif
 		//pReq->SgTable.SGCount = 1;
		pReq->SgTable.SGCount = cpu_to_le16(1);

#if defined(CONFIG_HIGHMEM64G) || defined(CONFIG_X86_64)
		//pReq->SgTable.table[0].StartAddress.Value = dma_handle;
		pReq->SgTable.table[0].StartAddress.Value = cpu_to_le64(dma_handle);
#else
  		pReq->SgTable.table[0].StartAddress.u.Low = (U32)(dma_handle);
#endif
		//pReq->SgTable.table[0].Count   = (U32) cmd->request_bufflen;
		pReq->SgTable.table[0].Count   = cpu_to_le32((U32) scsi_bufflen(cmd));
		pReq->SgTable.table[0].CtrlFlag = SG_CF_EOT|SG_CF_64B | SG_CF_HOST;

		pReq->SgTable.table[0].Page = virt_to_page(scsi_sglist(cmd));//add
  	}
	
	pReq->req.wSize = (U32)scsi_bufflen(cmd); //add by sandy 20061025	
  	pReq->req.pSgTable = &pReq->SgTable; 
  		
}

BoOL
Local_StartIO(
	bpOSD_COMP_EXTENSION OSDComponentExtension,
	REQ_HEAD * pReq,
	RequestCompletion Completion
	)
{
	bpREQ p_rq;
	bpOSD_COMP_EXTENSION pOSDExtension= OSDComponentExtension;

	p_rq=&pReq->req;
	p_rq->pOriginalRequest = (void *) pReq;
	Engine_InitializeREQ( pOSDExtension->ComponentResource[COMP_TYPE_ENGINE].ComponentExtension, p_rq );

	p_rq->Engine.Provider = pOSDExtension;
	p_rq->Engine.Completion = Completion ? Completion : RAID_Return;

#if defined(OSD_CHECK_REQ_TIMEOUT)
	if( Completion==0 )
	{
		GenList_AddTail( &pOSDExtension->CurrentReqList, p_rq );
		p_rq->Osd.flags = OSD_REQ_F_QUEUED;
		p_rq->Osd.tickCount = 0;
	}
#endif
	
#if !defined(DISABLE_PBM)
#if defined(USE_CC) 
	p_rq->CC.Provider = pOSDExtension;
	p_rq->CC.Completion = Completion ? Completion : RAID_Return;
#else
	p_rq->PBM.Provider = pOSDExtension;
	p_rq->PBM.Completion = Completion ? Completion : RAID_Return;
#endif
#endif	/* !defined(DISABLE_PBM) */

#if defined(DISABLE_PBM)	
	Engine_SubmitRAID( pOSDExtension->ComponentResource[COMP_TYPE_ENGINE].ComponentExtension, p_rq );
#else
	if( pOSDExtension->ComponentResource[COMP_TYPE_PBM].ComponentExtension )
		PBM_SubmitRAID( pOSDExtension->ComponentResource[COMP_TYPE_PBM].ComponentExtension, p_rq );
	else
		Engine_SubmitRAID( pOSDExtension->ComponentResource[COMP_TYPE_ENGINE].ComponentExtension, p_rq );
#endif

	return 0;

}

#include "eng_intr.h"
void CDB_XFORM(bpOSD_COMP_EXTENSION pOSDExtension, bpREQ p_rq, U8 cmd){
	

	if(p_rq->bID < MAX_LD_SUPPORTED)
	{
        	if(scsiIsReadWrite(cmd) || scsiIsVerify(cmd))
                {
                	bpRaidEngine This = (bpRaidEngine)OSD_GetComponentExtension(pOSDExtension, COMP_TYPE_ENGINE);
                        bpARY p_ary = Engine_GetArrayInfo( This, p_rq->bID );
                        U16     AccessCount;
                        U64     AccessLBA;

                        if( p_ary->bBlkSize != 1 )
                        {
                        /* Modify Count & LBA to suit with 2T read/write/vwrify */
                        	GET_COUNT_FROM_SCSI_CDB( p_rq->bCDB, AccessCount);
                                AccessCount = AccessCount * (U16)p_ary->bBlkSize;
                                COMPOSE_SCSI_CDB_COUNT( p_rq->bCDB, AccessCount );

                                GET_LBA_FROM_SCSI_CDB( p_rq->bCDB, AccessLBA);
                                AccessLBA = U64_Multiply_U32( AccessLBA, (U32)p_ary->bBlkSize );
                                COMPOSE_SCSI_CDB_LBA( p_rq->bCDB, AccessLBA);
                        }
                }
        }
}

#if defined(ATI)
static void t3_set_sense(struct scsi_cmnd *cmd, u8 sk, u8 asc, u8 ascq)
{
	cmd->result = (DRIVER_SENSE << 24) | SAM_STAT_CHECK_CONDITION;

	cmd->sense_buffer[0] = 0x70;    /* fixed format, current */
	cmd->sense_buffer[2] = sk;
	cmd->sense_buffer[7] = 18 - 8;  /* additional sense length */
	cmd->sense_buffer[12] = asc;
	cmd->sense_buffer[13] = ascq;
}

static void t3_invalid_field(struct scsi_cmnd *cmd,
			       void (*done)(struct scsi_cmnd *))
{
	/* "Invalid field in cbd" */
	t3_set_sense(cmd, ILLEGAL_REQUEST, 0x24, 0x0);
	done(cmd);
}
#endif

/* function   : static int t3_queue(Scsi_Cmnd *cmd, void (*fn)(Scsi_Cmnd *))
 * input        : cmd = SCSI command
 *		     : fn = command completion function
 * output      : 0
 * description  : SCSI queuecommand function
 */

static int
t3_queue(Scsi_Cmnd *cmd, void (*fn)(Scsi_Cmnd *)){
	bpOSD_COMP_EXTENSION bpOSDCompExtension=NULL;
	bpOSD_COMP_EXTENSION p;
	REQ_HEAD		*pReq;
	int i,us;
 	struct Scsi_Host *phost;
   	int          iret;   
	unsigned int channel,id,lun;
	
	OSD_TRACE( ("Enter t3_queue\n") );
	/* Step1: get extension pointer and do some security check */
#if VDEBUG	 	
	if(gIoctlFlag)	
		OSD_DPRINT( ("Oh, My God, we will call Queue command routine in IOCLT handle routine \n") );	
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
 	phost = cmd->host;
	channel = cmd->channel;
	id = cmd->target;
	lun = cmd->lun;
#else
	phost = cmd->device->host;
	channel = cmd->device->channel;
	id = cmd->device->id;
	lun = cmd->device->lun;
#endif

	for(i = 0; i < MAX_ADAPTORS; i++){
		if(t3_hostp[i]){
			bpOSDCompExtension=OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[i]);
			if(phost == bpOSDCompExtension->host)
			break;
		}	
	}
	if(i >= MAX_ADAPTORS || !phost || channel != 0 || id >= OSDM_MAX_TARGET_NUM || lun >= OSDM_MAX_LUN_PER_TARGET) {
    		cmd->result = (DID_BAD_TARGET << 16);
    		fn(cmd);
    		return 0;
 	 }

	/*Step2: get req and initialize req */
	if( (pReq = get_req_from_pool(bpOSDCompExtension) )== NULL){
		cmd->result = (DID_BUS_BUSY << 16);
		fn(cmd);
		return(0);
	}	
		
	pReq->cmd                 = (void *)cmd ;
   	pReq->fn                  = (void *)fn  ;
	pReq->req.bAdapterStatus 	= 1 ;
   	pReq->req.bTargetStatus  	= 0 ;
   	pReq->req.bID     	= id ;
   	pReq->req.bLUN    	= lun ;
   	pReq->req.bSenseSize     	= SCSI_SENSE_BUFFERSIZE ;
 	//pReq->req.p_buf          	= (unchar *)cmd->buffer ;
	pReq->req.p_buf			= (unchar *)scsi_sglist(cmd) ; //for kernel > 2.6.18, 20070423, sandy
       	pReq->req.p_sns          	= (unchar *)cmd->sense_buffer ;
	
       	pReq->req.bCdbSize          	= cmd->cmd_len ;
       	//pReq->req.wSize          	= cmd->bufflen ;
	pReq->req.wSize                 = scsi_bufflen(cmd) ; //for kernel > 2.6.18, 20070423, sandy

	//if(pReq->ReqType)
		//OSD_DPRINT( ("t3_queue: ReqType=0x%x\n",pReq->ReqType) );      
        OSD_TRACE( ("t3_queue: req = 0x%p, ReqType = 0x%x, cdb[0]=0x%x\n", pReq, pReq->ReqType, cmd->cmnd[0]) );
	
	//printk("t3_queue: cdb[0]=0x%x\n", cmd->cmnd[0]);

   	for( us=0 ; us < MAX_COMMAND_SIZE ; us++ ) {
	   	pReq->req.bCDB[us] = cmd->cmnd[us] ;
   	}


 	if(scsi_to_pci_dma_dir(cmd->sc_data_direction)==PCI_DMA_FROMDEVICE){
	pReq->req.bDataDir |= ENG_REQ_DATA_IN;
          }
 	if(scsi_to_pci_dma_dir(cmd->sc_data_direction)==PCI_DMA_TODEVICE){
	pReq->req.bDataDir |= ENG_REQ_DATA_OUT;
          }


#if defined(SUPPORT_2TERABYTE)
	CDB_XFORM(bpOSDCompExtension, &pReq->req, pReq->req.bCDB[0]);
#endif

	/*Step3: if R/W cmd, prepare sg table */
 	if(scsi_to_pci_dma_dir(cmd->sc_data_direction)!=PCI_DMA_NONE){
 		prepare_sg_table(cmd, pReq, bpOSDCompExtension->pdev);
  	}

	/*Step4: send cmd to pbm/engine */
	p=bpOSDCompExtension;
		

#if VDEBUG	
	gFlag = 1;
#endif
	iret=Local_StartIO(bpOSDCompExtension, pReq, NULL);
#if VDEBUG
	gFlag = 0;
#endif	
	
	
	OSD_TRACE( ("Leave t3_queue\n") );	
    	return iret;
}

void SynchronizeCacheCompletion ( 
	bpVOID Sender, 
	bpREQ p_rq )
{
	REQ_HEAD *pReq = (REQ_HEAD *)p_rq->pOriginalRequest;

	OSD_TRACE( ("Synchronize Cache completion, continue on shuting down...\n") );

	pReq->ReqType &= ~PENDING_REQ_HEAD_TYPE;
	
	if(!(pReq->ReqType & SLEEPING_REQ_HEAD_TYPE) )
			wake_up(&(pReq->waitq) );
}

void StopBGACompletionToContinueShutdown ( 
	bpVOID Sender, 
	bpREQ p_rq )
{
	bpOSD_COMP_EXTENSION This = (bpOSD_COMP_EXTENSION) Sender;
	REQ_HEAD *pReq = (REQ_HEAD *)p_rq->pOriginalRequest;
	
	p_rq->bCDB[0] = scsiSYNCHRONIZE_CACHE;

	OSD_TRACE( ("BGA stopped, continue on shuting down...\n") );

#if defined(SUPPORT_ENCLOSURE)
	CAM_StopEnclosureModule( OSD_GetComponentExtension(This, COMP_TYPE_CAM) );
#endif

	Local_StartIO( This, pReq, SynchronizeCacheCompletion);
}

int release_single_device(bpOSD_COMP_EXTENSION p)
{
	REQ_HEAD *pReq;
	unsigned long flags;
	int i;
	
	/* Step1: send req to stop bga */

	for(i=0; i<CONSOLEDEVICE_TARGETID; i++){
		if( (pReq = get_req_from_pool(p) )== NULL){
			return 0;
		}
		
		init_waitqueue_head(&(pReq->waitq) );
		pReq->req.bAdapterStatus 	= 1 ;
   		pReq->req.bTargetStatus  	= 0 ;
   		pReq->req.bID     	= i;
   		pReq->req.bLUN    = 0 ;
   		pReq->req.bCDB[0] = svucCONTROLLER_COMMAND;
   		pReq->req.bCDB[1] = ccmdSTOP_ALL_BGA;
   		pReq->req.bCDB[2] = MT_ACT_AUTOPAUSE;
	 	pReq->req.bSenseSize = SCSI_SENSE_BUFFERSIZE ;
       		pReq->req.p_sns = p->SenseBuffer;
		
		pReq->ReqType = PENDING_REQ_HEAD_TYPE + SLEEPING_REQ_HEAD_TYPE;
   		
		DRIVER_LOCK(p->host,flags);
	
		Local_StartIO(p, pReq, StopBGACompletionToContinueShutdown);
		
		DRIVER_UNLOCK(p->host,flags);
		
   		pReq->ReqType &=~SLEEPING_REQ_HEAD_TYPE;

		if(PENDING_REQ_HEAD_TYPE & pReq->ReqType)

			wait_event(pReq->waitq, !(pReq->ReqType & PENDING_REQ_HEAD_TYPE) );
		
		put_req_to_pool(p, pReq);
		
	}


	/*Step2: stop component and delete unrelease timers */
	OSDI_StopComponents(p);

	for ( i=0; i<MAX_TIMER_QUEUE; i++) {
		if ( p->TimerQueue[i].flag ) 
                        del_timer( p->TimerQueue[i].list );
	}

	/*Step3: free irq & unmap resource*/
	free_irq(p->irq, (void *)p);
	iounmap(p->BaseAddress[3]);
	iounmap(p->BaseAddress[4]);
	iounmap(p->BaseAddress[5]);
	
	if(p->DMASafeAddress) 
		pci_free_consistent(p->pdev, p->DMASafeSize, p->DMASafeAddress, p->DMAAddr);
	pci_release_regions(p->pdev);
	pci_disable_device(p->pdev);	
	pci_set_drvdata(p->pdev, NULL);
	
	for(i=0; i < NumAdapter; i++){
		
		if(t3_hostp[i] && (t3_hostp[i] == p->DeviceExtension) ){	
			vfree(p->DeviceExtension);	
			//OSD_TRACE( ("Clear hostp in Adapter id %d hostp 0x%p, extension 0x%p\n", i, fasttrak_hostp[i], p) );
			t3_hostp[i] = NULL;
			break;
		}
	}		
	return 1;
	
}

int fasttrak_set_dma_mask(struct pci_dev * pdev)
{
#if 1
	if (sizeof(dma_addr_t) > 4) {
		/* Update our PCI device dma_mask for full 64 bits */
		if (pci_set_dma_mask(pdev, 0xffffffffffffffffULL) == 0) {
			
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
			if (pci_set_consistent_dma_mask(pdev,
			    0xffffffffffffffffULL)) {
				OSD_DPRINT( ("Failed to set 64 bit PCI consistent mask, using 32 bit.\n") );
				return(pci_set_consistent_dma_mask(pdev,
				    0xffffffffULL) );
			}
#endif
			return 0;
		} else {
			OSD_DPRINT( ("Failed to set 64 bit PCI DMA mask, falling back to 32 bit MASK.\n") );
			return(pci_set_dma_mask(pdev, 0xffffffff) );
		}
	} else {
		return(pci_set_dma_mask(pdev, 0xffffffff) );
	}
#else		
	return(pci_set_dma_mask(pdev, 0xffffffff) );
#endif
}

//#if ( (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0) ) || (CONFIG_X86_64) )
//#if ( LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0) ) 
int init_pci_resource( bpOSD_COMP_EXTENSION pOSDExtension,
                       struct pci_dev* pdev )
{
	int i;
	
	for(i=0; i<6; i++){
		if (pci_resource_len(pdev, i) == 0){
			pOSDExtension->BaseAddress[i] = 0;
			continue;
		}			
		if(pci_resource_flags(pdev, i) & IORESOURCE_IO){
			pOSDExtension->BaseAddress[i] = (LPVOID)pci_resource_start(pdev, i);
			//printk("in IORESOURCE_IO, pOSDExtension->BaseAddress[%d] = %p\n", i, pOSDExtension->BaseAddress[i]);
		}
				
		if(pci_resource_flags(pdev, i) & IORESOURCE_MEM){
			pOSDExtension->BaseAddress[i] = (LPVOID)ioremap(pci_resource_start(pdev,i), pci_resource_len(pdev,i));
		}


		OSD_TRACE( ("BA[%d]=%p\n",i,pOSDExtension->BaseAddress[i] ) );
	}

	return 0;

}
//#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)

/* function   : static int t3_biosparam(Disk *disk, kdev_t dev, int Geometry[])
 * input        : Standard Parameters
 * output      : 0
 * description  : SCSI biosparam function
 */
static int t3_biosparam(Disk *disk, kdev_t dev, int Geometry[])
{

	if (disk->capacity > 0x200000) {	// 1GB
  		Geometry[0]=255;	// heads
  		Geometry[1]=63;  	// sectors
  		Geometry[2]=disk->capacity/(Geometry[0]*Geometry[1]); // cylinders

		/* capacity larger than 526GB(C/H/S = 65535/255/63) commented by isaac for fdisk issue
  		if (Geometry[2] > 65535) {
   	   		Geometry[2] = 65535;
   	   		Geometry[1] = disk->capacity / (Geometry[2]*Geometry[0]);
  		} */ 
   	}else{
   		Geometry[0]=64;  		
   		Geometry[1]=32;  		
   		Geometry[2]=disk->capacity / (Geometry[0]*Geometry[1]);  
   	}

	OSD_TRACE( ("capacity = 0x%x, Heads = 0x%x, Sectors = 0x%x, Cylinders = 0x%x\n", disk->capacity, Geometry[0], Geometry[1], Geometry[2]) );
   	return 0;
}

#if 0
void init_ioport(bpOSD_COMP_EXTENSION pOSDExtension)
{
	U8 bus=pOSDExtension->bus_num;
   	U8 devfn=pOSDExtension->devfn;
   	U32 base[6];
   	U8 uc;
   	
   	for( uc = 0 ; uc < 6 ; uc++ ) {
     		pcibios_read_config_dword(bus,devfn,PCI_BASE_ADDRESS_0+4*uc,(unsigned int *)&base[uc]);
     		base[uc] = base[uc] & PCI_BASE_ADDRESS_IO_MASK ;
   	}
   	pOSDExtension->BaseAddress[0] = (LPVOID)base[0] ;
   	pOSDExtension->BaseAddress[1] = (LPVOID)base[1] ;
   	pOSDExtension->BaseAddress[2] = (LPVOID)ioremap(base[2],0x100000) ;
   	pOSDExtension->BaseAddress[3] = (LPVOID)base[3] ;
   	pOSDExtension->BaseAddress[4] = (LPVOID)ioremap(base[4],0x100000);
   	pOSDExtension->BaseAddress[5] = (LPVOID)base[5] ;
   
}
#endif

/* function   : static int fasttrak_init_device(Scsi_Host_Template *template,struct pci_dev *fasttrak_dev)
 * input        : template = the SCSI host template
 *		     : fasttrak_dev = PCI device(FastTrak adapter)
 		     : Type = FastTrak controller type
 * output      : 0 if success, 1 if fail
 * description  : save device information
 */

static int fasttrak_init_device(Scsi_Host_Template *template,struct pci_dev *fasttrak_dev,int Type )
{
	struct Scsi_Host *shpnt;
	unsigned long flags;
	bpOSD_COMP_EXTENSION pOSDExtension;
	unsigned long DMAMemoryRequirement = 0;
	u32 rc = PCIBIOS_SUCCESSFUL;
	U32 re_size=OSDI_GetComponentExtensionRequirement(FALSE);
	int i;

	/*Step1: enable and initialize pci device*/
	if ((rc = pci_enable_device(fasttrak_dev))){
		OSD_DPRINT( ("Cannot enable adapter\n") );
		goto err_msg;
	}

	rc = pci_request_regions(fasttrak_dev, FASTTRAK_DEV_NAME);
	if (rc)
		goto err_out;


	rc = fasttrak_set_dma_mask(fasttrak_dev);
	if (rc)
		goto err_out_regions;

	pci_set_master(fasttrak_dev);

	/*Step2: alloc and initialize scsi host */
	shpnt = scsi_register(template, 4);
	if (!shpnt) {
		OSD_DPRINT( ("call to scsi_register failed!\n") );
		rc = -ENOMEM;
		goto err_out_regions;
	}
	shpnt -> max_channel = 0;
    	shpnt -> max_id = OSDM_MAX_TARGET_NUM;
    	shpnt -> max_lun = OSDM_MAX_LUN_PER_TARGET;	
    	shpnt -> pci_dev = fasttrak_dev ;
	shpnt -> max_cmd_len = MAX_COMMAND_SIZE;

	/*Step3: allocate memory for component extension */
       	t3_hostp[NumAdapter] = (unsigned char *) vmalloc(re_size);
    	OSD_TRACE( ("t3_hostp =%p \n", t3_hostp[NumAdapter]) );
    	memset(t3_hostp[NumAdapter], 0, re_size);
	pOSDExtension=OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[NumAdapter]);

	pOSDExtension->host = shpnt;
	pOSDExtension->host_no = shpnt->host_no;
	pOSDExtension->AdapterIndex = NumAdapter;
	pOSDExtension->DeviceExtension = (bpVOID)(t3_hostp[NumAdapter]);	
	pOSDExtension->bus_num=fasttrak_dev->bus->number;
	pOSDExtension->devfn=fasttrak_dev->devfn;
	pOSDExtension->pdev = fasttrak_dev;
	pOSDExtension->present = 1;
	pOSDExtension->irq = fasttrak_dev->irq;
	pOSDExtension->init_status = NP_INIT_UNDERWAY;
	/* pOSDExtension->counter = 0; */
  	pOSDExtension->major = gMajor;

	pci_set_drvdata(fasttrak_dev, pOSDExtension);
	pOSDExtension->ControllerInfo.DeviceID = gVenDevID[Type];
	pOSDExtension->ControllerInfo.SubDeviceID = gSubVenDevID[Type];

	/* Step4: get uncached memory */
	DMAMemoryRequirement = 
		OSDI_GetUncachedMemoryRequirement(pOSDExtension, FALSE);
	//TBD: One way to know there is a physical DIMM or not.
#ifdef SIMULATED_DIMM
	DMAMemoryRequirement += ( pOSDExtension->SimulatedDimmSize = 
                                  OSDI_GetDIMMRequirement(pOSDExtension,FALSE) );
#endif
	pOSDExtension->DMASafeAddress = (LPVOID)pci_alloc_consistent(fasttrak_dev, DMAMemoryRequirement, &pOSDExtension->DMAAddr);
	if(NULL == pOSDExtension->DMASafeAddress){
		OSD_DPRINT( ("unable to allocate uncached memory 0x%x . \n", DMAMemoryRequirement) );
		rc = -ENOMEM;
		goto err_out_vmalloc;
	}

	OSD_TRACE( ("DMASafeAddress =%p \n", pOSDExtension->DMASafeAddress) );
	pOSDExtension->DMASafeSize = DMAMemoryRequirement;
	//pOSDExtension->DMASafeSize = DMAMemoryRequirement-pOSDExtension->SimulatedDimmSize;
	//add by sandy 20071225

#if defined(CONFIG_HIGHMEM64) || defined(CONFIG_X86_64)
	pOSDExtension->DMASafePhysicalAddress.Value = pOSDExtension->DMAAddr;
#else
	pOSDExtension->DMASafePhysicalAddress.u.High = 0;
	//pOSDExtension->DMASafePhysicalAddress.u.Low = pOSDExtension->DMAAddr;
	pOSDExtension->DMASafePhysicalAddress.u.Low =cpu_to_le32(VIRT_TO_BUS(pOSDExtension->DMASafeAddress)); //change by sandy 20070111
#endif
	/* Step5: register resources and interrupt handler */
	if(init_pci_resource(pOSDExtension, fasttrak_dev) ){
		rc = -ENOMEM;	
		goto err_out_uncach;
	}
	
#ifdef SIMULATED_DIMM
	DMAMemoryRequirement = OSDI_GetUncachedMemoryRequirement(pOSDExtension,FALSE);
	OSD_ASSERT(  DMAMemoryRequirement % 4 ); // align on a 16-byte boundary, really necessary?
	pOSDExtension->BaseAddress[BASE_ADDRESS_SIMULATED_DIMM] = (LPVOID) (pOSDExtension->DMASafeAddress + DMAMemoryRequirement);
#endif
	/*Step 6: Assigned resources for components, extension dimm, uncached memory */
	OSDI_AssignComponentExtension(pOSDExtension,(bpVOID)(t3_hostp[NumAdapter]),re_size);

	OSDI_AssignComponentResource(pOSDExtension);


	/*Step 7: Initialize & start components */

	OSDI_InitializeComponents(pOSDExtension,  gVenDevID[Type], gVenDevID[Type]);
	/* According to tony's advice, move request interrupt handle here to avoid unexpected operations */
	rc = request_irq(fasttrak_dev->irq, (void *)t3_intr, IRQF_SHARED, FASTTRAK_DEV_NAME, (void *)pOSDExtension);
	if(rc){
	   	OSD_DPRINT( ( " t3 %d request_irq %d error, rc = %d\n", pOSDExtension->host_no, fasttrak_dev->irq, rc) );
	   	goto err_out_iounmap;
   	}
  //add  	if(!template->use_new_eh_code)
	if(!template->use_new_eh_code)
	DRIVER_LOCK(pOSDExtension->host, flags);

	OSDI_StartComponents(pOSDExtension, COMP_TYPE_OSD);
  
  if(!template->use_new_eh_code)
	DRIVER_UNLOCK(pOSDExtension->host, flags);

	// Enable interrupt for initial requests...
	if(template->use_new_eh_code){
		spin_unlock(&io_request_lock);
		local_irq_enable();
	}//add

	OSD_TRACE( ("before wait event of init stage\n") );
	
//	OSD_RequestTimer( pOSDExtension, 60*SECOND_IN_TIMER, OsdInitTimeout, 0, 0);

	//wait_event(pOSDExtension->Init_Waitq, (pOSDExtension->init_status!=NP_INIT_UNDERWAY));
	for(;;){

                t3_wait_event_timeout(pOSDExtension->Init_Waitq, (pOSDExtension->init_status!=NP_INIT_UNDERWAY), 100);
		
                //touch_nmi_watchdog();
		TOUCH_NMI_WATCHDOG();

                if((pOSDExtension->init_status!=NP_INIT_UNDERWAY))

                	break;
        }//add by sandy for wait_event() cause 64bit crash


	if(pOSDExtension->init_status==NP_INIT_FAILED){
		for(i=0;i<MAX_TIMER_QUEUE;i++){
			if(pOSDExtension->TimerQueue[i].flag)
				del_timer(pOSDExtension->TimerQueue[i].list);
			}
		free_irq(fasttrak_dev->irq, (void *)pOSDExtension);
		printk(KERN_INFO
			"t3: host %d init failed, gave up\n",pOSDExtension->host_no);
		rc = -ENODEV;
		goto err_out_iounmap;
		}

#if defined(OSD_CHECK_REQ_TIMEOUT)
		OSD_RequestTimer( pOSDExtension, 2*SECOND_IN_TIMER, OsdReqTimeoutChecker, 0, 0);
#endif
	NumAdapter++;		
	return rc;

err_out_iounmap:
	iounmap(pOSDExtension->BaseAddress[3]);
	iounmap(pOSDExtension->BaseAddress[4]);
	iounmap(pOSDExtension->BaseAddress[5]);

err_out_uncach:
	pci_free_consistent(fasttrak_dev, pOSDExtension->DMASafeSize, pOSDExtension->DMASafeAddress, pOSDExtension->DMAAddr);
err_out_vmalloc:
	vfree(t3_hostp[NumAdapter]);
	t3_hostp[NumAdapter] = NULL;
err_out_host:
	scsi_unregister(shpnt);
err_out_regions:
	pci_release_regions(fasttrak_dev);
err_out:
	pci_disable_device(fasttrak_dev);
err_msg:	
	OSD_DPRINT( ("t3_detect: return error code %x\n", rc) );
	return rc;

}


/* function   : static int t3_notifier_func(struct notifier_block *pnb,unsigned long code, void *unused)
 * input        : Standard Parameters
 * output      : NOTIFY_DONE
 * description  : stop bga and enclosure, synchronize cache
 */
static int t3_notifier_func(struct notifier_block *pnb,unsigned long code, void *unused)
{
	bpOSD_COMP_EXTENSION p;
	int i;

	for(i=0; i < NumAdapter; i++){
		
		if(t3_hostp[i]){	
			p = OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[i]);
			release_single_device(p);
		}
	}		
	
	return(NOTIFY_DONE);
}

static struct notifier_block t3_power_off_nb={
	t3_notifier_func, NULL, 0
};


/* function   : static int t3_detect(Scsi_Host_Template *template)
 * input        : template = the SCSI host template
 * output      : number of adapters successfully detected
 * description  : SCSI detect function
 */

static int t3_detect(Scsi_Host_Template *template) 
{
	int  i;
	struct pci_dev *fasttrak_dev=NULL;	

#if defined(USE_EXPORT)
	Global_OSD_InitializeExports();
	OSDI_InitializeComponentInterfaceTable();
#endif
	//OSD_DPRINT( ("Promise NAPA Seriel Device Driver Version %s %s\n", FASTTRAK_DRIVER_VERSION, FASTTRAK_DRIVER_DATE ) );
#if defined(ATI)
	OSD_DPRINT( ("AMD AHCI Seriel Device Driver Version %s %s\n", FASTTRAK_DRIVER_VERSION, FASTTRAK_DRIVER_DATE ) );
#else
	OSD_DPRINT( ("Promise T3 SAS Seriel Device Driver Version %s %s\n", FASTTRAK_DRIVER_VERSION, FASTTRAK_DRIVER_DATE ) );
#endif

	if ( (gMajor = register_chrdev(0, FASTTRAK_DEV_NAME, (struct file_operations *)&t3_fops) ) < 0){
		OSD_DPRINT( ("T3: unable to register \"%s\" character device, error = %d \n", FASTTRAK_DEV_NAME, gMajor) );
		return 0;
	}
	
	template->name = FASTTRAK_DRIVER_NAME;
	template->sg_tablesize = FASTTRAK_MAX_SG;
#ifndef  _OBSOLETE_PROC_	
	template->proc_dir = &proc_scsi_t3;
   	template->proc_info = t3_proc_info;
#endif /*  _OBSOLETE_PROC_ */
#ifdef CONFIG_HIGHMEM64G
	template->highmem_io = 1;
#endif

	for( i = 0; i <MAX_ADAPTER_TYPE; i++){
   		while ((fasttrak_dev=pci_find_device(gVenID[i], gDevID[i], fasttrak_dev))){

			if(NumAdapter >= MAX_ADAPTORS){
				OSD_DPRINT( ("Too many t3 cards present\n") );
				break;
			}
			fasttrak_init_device(template, fasttrak_dev,i);
		}
	}

   	if(!NumAdapter){
   		template->present = 0;
		printk(KERN_INFO
			"t3 card does not exist!\n");
		if(gMajor > 0)
  			unregister_chrdev(gMajor,FASTTRAK_DEV_NAME);
		return 0;
   	}

	if(register_reboot_notifier(&t3_power_off_nb)){
		OSD_DPRINT( ("t3: unable to register power notifier!\n") );
		if(gMajor > 0)
  			unregister_chrdev(gMajor,FASTTRAK_DEV_NAME);
		return 0;
  	}
	
#if defined (_64BPLATFORM) && (LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14))
        register_ioctl32_conversion(IOCTL_FASTTRAK_GETVERSION, conversion_handler);
        register_ioctl32_conversion(IOCTL_FASTTRAK_PASSTHRU, conversion_handler);
#endif /* _64BPLATFORM */ 
/*add && LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14) by sandy 20070111 for kernel : 2.6.16; change #ifdef->#if defined*/

   	return NumAdapter;
   
}


/* function   : static int t3_release(struct Scsi_Host *host)
 * input        : host = pointer to the control structure
 * output      : 0 if success, -1 if failed
 * description  : flush buffer, release resources
 */
static int t3_release(struct Scsi_Host *host)
{
	bpOSD_COMP_EXTENSION p=NULL;
	int i;

	for(i = 0; i < MAX_ADAPTORS; i++){
		if(t3_hostp[i]){
			p = OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[i]);
			if(host == p->host)
			break;
		}	
	}

	if( i >= NumAdapter)
		return(-1);

	if( (NumAdapter-1) == i){
		unregister_reboot_notifier(&t3_power_off_nb); 

		if(p->major > 0)
  			unregister_chrdev(p->major,FASTTRAK_DEV_NAME);
	#if defined(_64BPLATFORM) && LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14)
	        unregister_ioctl32_conversion(IOCTL_FASTTRAK_GETVERSION);
        	unregister_ioctl32_conversion(IOCTL_FASTTRAK_PASSTHRU);
	#endif /* _64BPLATFORM */ //add by sandy 20070111
	}

	OSD_TRACE( ("Adapter id %d hostp 0x%p, extension 0x%p\n", i, t3_hostp[i], p) );
	release_single_device(p);
	scsi_unregister(host);	
	return 0;
}

static Scsi_Host_Template driver_template = (Scsi_Host_Template)T3_TEMPLATE;

#include "scsi_module.c"

#else

/* function   : static int t3_biosparam
 * input        : Standard Parameters
 * output      : 0
 * description  : SCSI biosparam function
 */
static int t3_biosparam(struct scsi_device *sdev, struct block_device *bdev, sector_t capacity, int *Geometry)
{
	int heads, sectors; 
	u64 cylinders;
 
	if (capacity > 0x200000) {	// 1GB
  		heads = 255;	// heads
  		sectors = 63;  	// sectors
		cylinders = capacity;  		
   		sector_div(cylinders, (heads*sectors) );  

		/* capacity larger than 526GB(C/H/S = 65535/255/63)  commented by isaac for fdisk issue
  		if (Geometry[2] > 65535) {
   	   		Geometry[2] = 65535;
   	   		Geometry[1] = capacity / (Geometry[2]*Geometry[0]);
  		} */ 
   	}else{
   		heads = 64;  		
   		sectors = 32;
		cylinders = capacity;  		
   		sector_div(cylinders, (heads*sectors) );  
   	}
	Geometry[0] = heads;
	Geometry[1] = sectors;
	Geometry[2] = (int)cylinders;

	OSD_TRACE( ("capacity = 0x%ullx, Heads = 0x%x, Sectors = 0x%x, Cylinders = 0x%x\n", capacity, heads, sectors, (int)cylinders) );
   	return 0;
}
	
static struct scsi_host_template driver_template = {
	.module	=THIS_MODULE,
	.name = FASTTRAK_DEV_NAME,
	.queuecommand = t3_queue,
	.eh_abort_handler = t3_abort,
	.eh_device_reset_handler = t3_reset,
	.eh_host_reset_handler = t3_reset,
	.bios_param = t3_biosparam,
	/*.can_queue = 1,*/
	.can_queue = CAN_QUEUE-2,
	.this_id = -1,
	.sg_tablesize = MAX_SG,
	.cmd_per_lun = CAN_QUEUE-2,
	.use_clustering = DISABLE_CLUSTERING,
#ifndef  _OBSOLETE_PROC_	
	.proc_dir = &proc_scsi_t3,                                               
    	.proc_info = t3_proc_info, 
#endif /*  _OBSOLETE_PROC_ */
	.proc_name = FASTTRAK_DEV_NAME,
};

#define PCI_COMMAND 0x04
#define PCI_COMMAND_INTX_DISABLE 0x400

static void pci_enable_intx(struct pci_dev *pdev)
{
        u16 pci_command;

        pci_read_config_word(pdev, PCI_COMMAND, &pci_command);
        if (pci_command & PCI_COMMAND_INTX_DISABLE) {
                OSD_DPRINT( ("So it is INTX/MSI?\n") );
                pci_command &= ~PCI_COMMAND_INTX_DISABLE;
                pci_write_config_word(pdev, PCI_COMMAND, pci_command);
        }
}

			
/**
 * t3_probe - Adapter hot plug add entry point
 *
 * Return value:
 * 	0 on success / non-zero on failure
 **/
static int __devinit t3_probe(struct pci_dev *pdev,
                                     const struct pci_device_id *dev_id)
{
	bpOSD_COMP_EXTENSION pOSDExtension;
	struct Scsi_Host * shpnt;
	u32 rc = PCIBIOS_SUCCESSFUL;
	ULONG DMAMemoryRequirement = 0;
	U32 re_size;
	unsigned long flags;
	int i;
	
	OSD_TRACE( (" Enter t3_probe \n") );	
	re_size = OSDI_GetComponentExtensionRequirement(FALSE);

	/*Step1: enable and initialize pci device*/
        rc = pci_enable_device(pdev);
	if ( rc ) {
		dev_err(&pdev->dev, "Cannot enable this device.\n");
		return rc;
	}

	rc = pci_request_regions(pdev, FASTTRAK_DEV_NAME);
	if (rc)
		goto err_out;

        pci_enable_intx(pdev);

	rc = fasttrak_set_dma_mask(pdev);
	if (rc)
		goto err_out_regions;

	pci_set_master(pdev);

	#if defined(ATI)
	dev_info(&pdev->dev, "Found AMD AHCI Controller %d:%d with IRQ: %d\n", dev_id->vendor, dev_id->device, pdev->irq);
	dev_info(&pdev->dev, "Driver version of AMD AHCI : %s\n", FASTTRAK_DRIVER_VERSION);
	#else	
	dev_info(&pdev->dev, "Found T3 SAS Controller %d:%d with IRQ: %d\n", dev_id->vendor, dev_id->device, pdev->irq);
	dev_info(&pdev->dev, "Driver version of T3 SAS : %s\n", FASTTRAK_DRIVER_VERSION);
	/*add for show driver version, sandy, 20071227*/
	#endif

	/*Step2: alloc and initialize scsi host */
	shpnt = scsi_host_alloc(&driver_template, 100);

	if (!shpnt) {
		dev_err(&pdev->dev, "call to scsi_host_alloc failed!\n");
		rc = -ENOMEM;
		goto err_out_regions;
	}

	shpnt -> max_channel = 0;
    	shpnt -> max_id = OSDM_MAX_TARGET_NUM;
    	shpnt -> max_lun = OSDM_MAX_LUN_PER_TARGET;	
	// jason
	shpnt -> max_cmd_len = MAX_COMMAND_SIZE;

	/*Step 3: get cached memory resource for extension*/
    	t3_hostp[NumAdapter] = (unsigned char *) vmalloc(re_size);
	if(NULL == t3_hostp[NumAdapter]){
		OSD_DPRINT( ("T3: unable to allocate cached memory 0x%x for extension. \n", re_size) );
		rc = -ENOMEM;
		goto err_out_host;
	}
    	memset(t3_hostp[NumAdapter], 0, re_size);    	
	pOSDExtension=OSDI_GetOSDExtensionFromDeviceExtension(t3_hostp[NumAdapter]);

	pOSDExtension->host = shpnt;
	pOSDExtension->host_no = shpnt->host_no;
	pOSDExtension->AdapterIndex = NumAdapter;
	pOSDExtension->DeviceExtension = (bpVOID)(t3_hostp[NumAdapter]);	
	pOSDExtension->bus_num=pdev->bus->number;
	pOSDExtension->devfn=pdev->devfn;
	pOSDExtension->pdev = pdev;
	pOSDExtension->present = 1;
	pOSDExtension->irq = pdev->irq;
  	pOSDExtension->major = gMajor;
	pOSDExtension->init_status = NP_INIT_UNDERWAY;

	pci_set_drvdata(pdev, pOSDExtension);
	
	pOSDExtension->ControllerInfo.DeviceID = (pdev->vendor)<<16|pdev->device;
	pOSDExtension->ControllerInfo.SubDeviceID =(pdev->subsystem_vendor)<<16|(pdev->subsystem_device); 
	DMAMemoryRequirement = 
  	/*Step 4 get uncached memory */
		OSDI_GetUncachedMemoryRequirement(pOSDExtension,FALSE);
	//TBD: One way to know there is a physical DIMM or not.
#ifdef SIMULATED_DIMM
	DMAMemoryRequirement += ( pOSDExtension->SimulatedDimmSize = 
                                  OSDI_GetDIMMRequirement(pOSDExtension,FALSE) );
#endif
	pOSDExtension->DMASafeAddress = (LPVOID)pci_alloc_consistent(pdev, DMAMemoryRequirement, &pOSDExtension->DMAAddr);
        OSD_DPRINT( ("VR Addr : %p - PY Addr : %p.\n", pOSDExtension->DMASafeAddress, pOSDExtension->DMAAddr) );
	if(NULL == pOSDExtension->DMASafeAddress){
		printk("pOSDExtension->DMASafeAddress = NULL\n");
		OSD_DPRINT( ("T3: unable to allocate uncached memory 0x%x . \n", DMAMemoryRequirement) );
		rc = -ENOMEM;
		goto err_out_vmalloc;
	}

	pOSDExtension->DMASafeSize = DMAMemoryRequirement;

#if defined(CONFIG_HIGHMEM64) || defined(CONFIG_X86_64)
	pOSDExtension->DMASafePhysicalAddress.Value = pOSDExtension->DMAAddr;
#else
	pOSDExtension->DMASafePhysicalAddress.u.High = 0;
	//pOSDExtension->DMASafePhysicalAddress.u.Low = pOSDExtension->DMAAddr;
//cpu_to_le32(VIRT_TO_BUS(pOSDExtension->DMASafeAddress));
	pOSDExtension->DMASafePhysicalAddress.u.Low =cpu_to_le32(VIRT_TO_BUS(pOSDExtension->DMASafeAddress));//sync tx4310(.31) by sandy 20070111
#endif

	/* Step5: register resources and interrupt handler */
        if ( init_pci_resource(pOSDExtension, pdev) ) {
                rc = -ENOMEM;
                goto err_out_uncach;
	}

#ifdef SIMULATED_DIMM
	DMAMemoryRequirement = OSDI_GetUncachedMemoryRequirement(pOSDExtension,FALSE);
	OSD_ASSERT(  DMAMemoryRequirement % 4 ); // align on a 16-byte boundary, really necessary?
	pOSDExtension->BaseAddress[BASE_ADDRESS_SIMULATED_DIMM] = (LPVOID) (pOSDExtension->DMASafeAddress + DMAMemoryRequirement);
#endif

	/*Step 6: Assigned resources for components, extension dimm, uncached memory */
	OSDI_AssignComponentExtension(pOSDExtension,(bpVOID)(t3_hostp[NumAdapter]),re_size);

	OSDI_AssignComponentResource(pOSDExtension);

	/*Step 7: Initialize & start components */
	OSDI_InitializeComponents(pOSDExtension,  (pdev->vendor)<<16|pdev->device, (pdev->subsystem_vendor)<<16|pdev->subsystem_device);
	
	rc = request_irq( pdev->irq, (void *)t3_intr, 
			  IRQF_SHARED, FASTTRAK_DEV_NAME, 
			  (void *)pOSDExtension );
	if (rc) {
	   	dev_err( &pdev->dev, "t3%x: request_irq()  %d error,"
			 "rc = %d\n",NumAdapter, pdev->irq, rc );
	   	goto err_out_iounmap;
   	}

	DRIVER_LOCK(pOSDExtension->host, flags);

	OSDI_StartComponents(pOSDExtension, COMP_TYPE_OSD);

	DRIVER_UNLOCK(pOSDExtension->host, flags);
	
	OSD_DPRINT( ("t3_probe: before wait event of init stage\n") );
		
	//OSD_RequestTimer( pOSDExtension, 60*SECOND_IN_TIMER, OsdInitTimeout, 0, 0);
	//wait_event(pOSDExtension->Init_Waitq, (pOSDExtension->init_status!=NP_INIT_UNDERWAY));
	for(;;){

                t3_wait_event_timeout(pOSDExtension->Init_Waitq, (pOSDExtension->init_status!=NP_INIT_UNDERWAY), 100);
		
                //touch_nmi_watchdog();
		TOUCH_NMI_WATCHDOG();

                if((pOSDExtension->init_status!=NP_INIT_UNDERWAY))

                        break;
        }//add by sandy for wait_event() cause 64bit crash


	if(pOSDExtension->init_status==NP_INIT_FAILED){
		for(i=0;i<MAX_TIMER_QUEUE;i++){
			if(pOSDExtension->TimerQueue[i].flag)
				del_timer(pOSDExtension->TimerQueue[i].list);
			}
		free_irq(pdev->irq, (void *)pOSDExtension);
		printk(KERN_INFO
			"t3: host %d init failed, gave up\n",pOSDExtension->host_no);
		rc = -ENODEV;
		goto err_out_iounmap;
		}


	NumAdapter++;	

	rc = scsi_add_host(shpnt, &pdev->dev);
	if (rc)
		goto err_out_freeirq;

	scsi_scan_host(shpnt);

#if defined(OSD_CHECK_REQ_TIMEOUT)
	OSD_RequestTimer( pOSDExtension, SECOND_IN_TIMER, OsdReqTimeoutChecker, 0, 0);
#endif

#if defined (_64BPLATFORM) && (LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14))
        register_ioctl32_conversion(IOCTL_FASTTRAK_GETVERSION, conversion_handler);
        register_ioctl32_conversion(IOCTL_FASTTRAK_PASSTHRU, conversion_handler);
#endif /* _64BPLATFORM */
/*add && LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14) by sandy 20070111; change #ifdef->#if defined*/
	return 0;

err_out_freeirq:
	free_irq(pdev->irq, (void *)pOSDExtension);
err_out_iounmap:
	iounmap(pOSDExtension->BaseAddress[3]);
	iounmap(pOSDExtension->BaseAddress[4]);
	iounmap(pOSDExtension->BaseAddress[5]);
err_out_uncach:
	pci_free_consistent(pdev, pOSDExtension->DMASafeSize, pOSDExtension->DMASafeAddress, pOSDExtension->DMAAddr);
err_out_vmalloc:
	vfree(t3_hostp[NumAdapter]);
	t3_hostp[NumAdapter] = NULL;
err_out_host:
	scsi_host_put(shpnt);
err_out_regions:
	pci_release_regions(pdev);
err_out:
	pci_disable_device(pdev);

	return rc;
}

/* add SYNC_CACHE for the command of turning off leds that can't write to the dimm immediately */
/* 20070713 by sandy */
void SYNC_CACHE(){
        //printk("\n");
	mdelay(1000);
}

/**
 * t3_remove - adapter hot plug remove entry point
 * @pdev:	pci device struct
 *
 * Adapter hot plug remove entry point.
 *
 * Return value:
 * 	none
 **/
static void __devexit t3_remove(struct pci_dev *pdev)
{
	bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)pci_get_drvdata(pdev);
	
	scsi_remove_host(p->host);

	release_single_device(p);
	
	SYNC_CACHE;
}

/**
 * t3_shutdown - Shutdown handler.
 * @dev:	device struct
 *
 * This function is invoked upon system shutdown/reboot. It will issue
 * an adapter shutdown to the adapter to flush the write cache.
 *
 * Return value:
 * 	none
 **/

static void t3_shutdown_1(struct device *dev)
{
        bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)pci_get_drvdata(to_pci_dev(dev) );

        release_single_device(p);

        SYNC_CACHE;
}

//static void t3_shutdown(struct device *dev)
static void t3_shutdown_2(struct pci_dev *pdev)
{
	//bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)pci_get_drvdata(to_pci_dev(dev) );

	bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)pci_get_drvdata(pdev);

	release_single_device(p);
	
	SYNC_CACHE;
}
/* change it for kernel version > 2.6.16  */

static struct pci_device_id t3_pci_table[] __devinitdata = {
#if defined(OCTOPUSII)
        { 0x105a, 0x3571, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x3519, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x3574, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
#elif defined(NAPA_MARVELL)
        { 0x11ab, 0x6081, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
#elif defined(NAPA_FPGA)
	/* SX4300/8300*/
        { 0x105a, 0x6300, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6301, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x6302, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6303, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6304, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x6305, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6306, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6307, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
/*#elif defined(AHCI_INTEL)
        { 0x8086, 0x2652, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, // ICH6 
        { 0x8086, 0x2653, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, // ICH6M 
        { 0x8086, 0x27c1, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, // ICH7 
        { 0x8086, 0x27c5, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, // ICH7M 
        { 0x8086, 0x27c3, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, // ICH7R 
        { 0x1002, 0x4380, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x1002, 0x4381, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x8086, 0x2652, 0x1043, 0x2604, 0, 0, 0 }, // ICH6R
	{ 0x8086, 0x2652, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },*/
#elif defined(SUPPORT_T3)
        /*{ 0x105a, 0x3775, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x3776, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x3777, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x3778, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x3f17, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x3f18, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },*/
        /*{ 0x105a, 0x3f19, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },*/
	/*{ 0x105a, 0x3f20, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },*/
	{ 0x105a, 0x3f20, 0x105a, 0x3716, 0, 0, 0 }, //FastTrak PDC42819; SubDeviceID 3F20 -> 3716(20070625)
	{ 0x105a, 0x3f20, 0x105a, 0x3f21, 0, 0, 0 }, //FastTrak TX2650
	{ 0x105a, 0x3f20, 0x105a, 0x3f22, 0, 0, 0 }, //FastTrak TX4650
	{ 0x105a, 0x3f19, 0x105a, 0x3f29, 0, 0, 0 }, //SATA TX2650
	{ 0x105a, 0x3f19, 0x105a, 0x3f2a, 0, 0, 0 }, //SATA TX4650
	{ 0x105a, 0x3f19, 0x105a, 0x3f2b, 0, 0, 0 }, //SATA TX4652
	{ 0x105a, 0x3f20, 0x105a, 0x3f23, 0, 0, 0 }, //FastTrak TX4650R1
	
        /*{ 0x105a, 0x3f20, 0x105a, 0x3516, 0, 0, 0 },*/ //remove for some sub-device ID is 0x3f20

#elif defined(ATI)
        { 0x1002, 0x4380, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x1002, 0x4381, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x1002, 0x4382, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x1002, 0x4391, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x1002, 0x4392, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x1002, 0x4393, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
	  0 },
        { 0x8086, 0x2822, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
	  0 },
        { 0x1002, 0x5059, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
	  0 },


#else
	/* SX4/4000/4100*/
        { 0x105a, 0x6621, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6622, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 },
        { 0x105a, 0x6623, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
        { 0x105a, 0x6624, PCI_ANY_ID, PCI_ANY_ID, 0, 0,
          0 }, 
#endif
	{0, 0, 0, 0, 0, 0, 0UL},
};


MODULE_AUTHOR("Sandy Tan");
//MODULE_DESCRIPTION("Promise Technology NAPA-based AHCI Controllers");
//MODULE_DESCRIPTION("Promise Technology T3 SAS Controllers");

#ifndef T3
MODULE_DESCRIPTION("AMD AHCI Seriel Controllers");
#else
MODULE_DESCRIPTION("Promise Technology FastTrak T3 Seriel Controllers");
#endif
MODULE_VERSION(FASTTRAK_DRIVER_VERSION);
/*add for show driver version, sandy, 20071227*/
MODULE_LICENSE("GPL");
MODULE_DEVICE_TABLE(pci, t3_pci_table);

static struct pci_driver t3_driver = {
	.name = FASTTRAK_DEV_NAME,
	.id_table = t3_pci_table,
	.probe = t3_probe,
	.remove = t3_remove,
	#if LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14)
	.driver = {
	.shutdown = t3_shutdown_1,
	},
	#else
	.shutdown = t3_shutdown_2,
	#endif
	//add by sandy 20070111 (avoid insmod driver error on LINUX_VERSION_CODE > KERNEL_VERSION(2,6,14))
	//marked it for LED problem of Enclosure, 20070725, sandy
	//changed it for kernel version > and < 2.6.14, 20070730, sandy 
};

/**
 *   t3_init - Module entry point
 *
 *   Return value:
 * 	 0 on success / non-zero on failure
 **/
static int __init t3_init(void)
{
#if defined(USE_EXPORT)
	Global_OSD_InitializeExports();
	OSDI_InitializeComponentInterfaceTable();
#endif

	//OSD_DPRINT( ("Promise FastTrak AHCI (napa) Serieal Device Driver %s %s\n", FASTTRAK_DRIVER_VERSION, FASTTRAK_DRIVER_DATE) );
	OSD_DPRINT( ("Promise FastTrak T3 SAS Serieal Device Driver %s %s\n", FASTTRAK_DRIVER_VERSION, FASTTRAK_DRIVER_DATE) );

	if ( (gMajor = register_chrdev(0, FASTTRAK_DEV_NAME, (struct file_operations *)&t3_fops) ) < 0){
		OSD_DPRINT( ("t3: unable to register \"%s\" character device, error = %d \n", FASTTRAK_DEV_NAME, gMajor) );
		return 0;
	}
	
//	if (!pci_register_driver(&ahci_napa_driver) ) {
        //      	pci_unregister_driver(&ahci_napa_driver);
        //return -ENODEV;
    	//}

	//return pci_register_driver( &t3_driver );
	#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
	if (!pci_register_driver(&t3_driver) ) {
        	pci_unregister_driver(&t3_driver);
        	return -ENODEV;
    	}
        return 0;
	#else    
	return pci_register_driver(&t3_driver);
	#endif /* KERNEL_VERSION_CODE < KERNEL_VERSION(2.6.10) */ //add by sandy 20070111
}

/**
 * t3_exit - Module unload
 *
 * Module unload entry point.
 *
 * Return value:
 * 	none
 **/
static void __exit t3_exit(void)
{
	if(gMajor > 0)
  		unregister_chrdev(gMajor, FASTTRAK_DEV_NAME);

	#if defined(_64BPLATFORM) && LINUX_VERSION_CODE<KERNEL_VERSION(2,6,14)
        unregister_ioctl32_conversion(IOCTL_FASTTRAK_GETVERSION);
        unregister_ioctl32_conversion(IOCTL_FASTTRAK_PASSTHRU);
	#endif /* _64BPLATFORM */ //add by sandy 20070111
	pci_unregister_driver(&t3_driver);
}

module_init(t3_init);
module_exit(t3_exit);

#endif
