/*-M*************************************************************************
 * Promise T3 device driver for Linux.
 *
 * Copyright (c) 2001  Promise Technology, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * --------------------------------------------------------------------------  
 * Copyright (c) 1999-2001 Promise Technology, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *-M*************************************************************************/

#ifndef OSD_MAIN_h
#define OSD_MAIN_h


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
/* I have to disable use_new_eh_code, for I don't know why driver will hang 
  in SMP kernel after enable this feature, I will work on it later  */
#define T3_TEMPLATE {                                                  \
    proc_dir: NULL,                                               \
    proc_info: t3_proc_info,                                 \
    name: "T3",                                                   \
    detect: t3_detect,                                        \
    release: t3_release,			\
    info: NULL,                                            \
    command: NULL,                                                \
    queuecommand: t3_queue,                                   \
    eh_strategy_handler: NULL,				\
    eh_abort_handler: t3_abort,			\
    eh_device_reset_handler: NULL,		\
    eh_bus_reset_handler: NULL,		\
    eh_host_reset_handler: t3_reset,				\
    abort: t3_abort,						\
    reset: t3_reset,						\
    bios_param: t3_biosparam,                                 \
    can_queue: CAN_QUEUE-2,                                         \
    this_id: -1,                                                  \
    sg_tablesize: MAX_SG,                                              \
    cmd_per_lun: CAN_QUEUE-2,                                               \
    unchecked_isa_dma: 0,                                         \
    use_clustering: ENABLE_CLUSTERING,                            \
    use_new_eh_code: 0,                                            \
    proc_name: "t3"						\
}		

#endif

#define VIRT_TO_BUS(a) (u32)virt_to_bus((void *)(a))
#define BUS_TO_VIRT(a) bus_to_virt((unsigned long)(a))


//#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
int wrap_print(const char *fmt,...);
//#endif

void 
init_req_pool(bpOSD_COMP_EXTENSION p);

PREQ_HEAD 
get_req_from_pool(bpOSD_COMP_EXTENSION p);

void 
put_req_to_pool(bpOSD_COMP_EXTENSION p, PREQ_HEAD pReq);

void 
init_ioport(bpOSD_COMP_EXTENSION pOSDExtension);

void 
WaitInitRaid(ulong dev);

char 
EndRequest(void *cmnd,void *fun,int result);

void 
RAID_Return(void *sender,bpREQ request);

void
prepare_sg_table(Scsi_Cmnd* cmd, REQ_HEAD* pReq, struct pci_dev *pDev);

BoOL
Local_StartIO(
	bpOSD_COMP_EXTENSION OSDComponentExtension,
	REQ_HEAD * pReq,
	RequestCompletion Completion
);

void 
SynchronizeCacheCompletion ( bpVOID Sender, bpREQ p_rq );

void 
StopBGACompletionToContinueShutdown ( bpVOID Sender, bpREQ p_rq );

void 
release_timer_routine(unsigned long arg);

int
release_single_device(bpOSD_COMP_EXTENSION p);

#endif /* OSD_MAIN_H */
