/***************************************************************************
*
* Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
* No part of this document may be reproduced or transmitted in any form or
* by any means, electronic or mechanical, for any purpose, without the
* express written permission of Promise Technology, Inc.
*
***************************************************************************/

/***************************************************************************
*
* Author		:Isaac Huang
*
* Module		:OSD Timer Management
* Revision		:1.0.0.1
* Checkin Date	:11/05/2004
*
* Description	:Timer Management
*				To reduce complexity, periodical Timer is removed for two reason.
*				1. In TimerService, when navigating list, cannot insert periodical Timer easily.
*				2. In Callback function, user may call the periodical Timer.
* History		:
*
***************************************************************************/
#include "osd_inc.h"

/*
void 
linux_init_timer(struct linux_timer_list * timer) 
{
  	init_timer((struct timer_list *)timer);
}

void 
linux_add_timer(struct linux_timer_list * timer) 
{
  	add_timer((struct timer_list *)timer);
}

void 
linux_del_timer(struct linux_timer_list * timer)
{
  	del_timer((struct timer_list *)timer);
}
*/


//#define NP_UDELAY_MAX 1000 
#define NP_UDELAY_MAX 500 //changed for nmi_waatchdog problem
void 
linux_delay(U32 DelayTime)
{
#if 0
	int i;
	U32 s=DelayTime/1000000;
	U32 us=DelayTime%1000000;
	U32 ms=us/1000;
	
	us=us%1000;
	if(s){
		set_current_state(TASK_UNINTERRUPTIBLE);
		schedule_timeout(s * HZ);
	}

	if(ms){
		for(i=0; i<ms; i++)
			udelay(1000);
	}

	if(us)
		udelay(us);
#endif

	int i;
	U32 ms=DelayTime/NP_UDELAY_MAX;
	U32 us=DelayTime%NP_UDELAY_MAX;
	if(ms){
		//for(i = 0; i < ms; i++){ //changed by sandy 20070404
                for(i = 0; i < 2*ms; i++){
			udelay(NP_UDELAY_MAX);
			//touch_nmi_watchdog();//add 20070108 by sandy to avoid nmi_waatchdog on 64bit crash when insmod
			TOUCH_NMI_WATCHDOG();
		}
	}

	if(us)
		udelay(us);
	//touch_nmi_watchdog();//add 20070108, 0130
	TOUCH_NMI_WATCHDOG();
}


unsigned long volatile 
linux_get_jiffies(void) 
{
	return jiffies;
}

void 
init_timer_queue(bpVOID OSDExtension)
{
	bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)OSDExtension;
	int i;
	for (i=0;i<MAX_TIMER_QUEUE;i++)
	{
		p->TimerQueue[i].list= &(p->TimerListPool[i]);
		p->TimerQueue[i].flag=0;
		if(MAX_TIMER_QUEUE -1 == i)
			p->TimerQueue[i].next=NULL;
		else
			p->TimerQueue[i].next=&(p->TimerQueue[i+1]);
	}	
	
	p->pTimerCurrent = p->TimerQueue;
	
	return;	
}
struct Timer_Queue * 
alloc_timer_queue(bpVOID OSDExtension)
{
	bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)OSDExtension;
	unsigned long flags;
	struct Timer_Queue *ptimer;
	
	spin_lock_irqsave(&p->timer_lock, flags);
	
	ptimer = p->pTimerCurrent;

	if(NULL == ptimer){
		OSD_DPRINT( ("alloc_timer_queue: timer pool is empty\n") );
		spin_unlock_irqrestore(&p->timer_lock, flags);
		return NULL;
	}	
	
	p->pTimerCurrent = ptimer->next;

	spin_unlock_irqrestore(&p->timer_lock, flags);
	
	ptimer->next = NULL;
	ptimer->flag=1;

	return ptimer;
}

void 
release_timer_queue(bpVOID OSDExtension, struct Timer_Queue *ptimer)
{
	bpOSD_COMP_EXTENSION p = (bpOSD_COMP_EXTENSION)OSDExtension;
	unsigned long flags;

	spin_lock_irqsave(&p->timer_lock, flags);
	
	if(NULL == ptimer){
		OSD_DPRINT( ("release_timer_queue: intend to put NULL timer to pool \n") );
		spin_unlock_irqrestore(&p->timer_lock, flags);
		return;
	}	
	ptimer->flag=0;
	del_timer(ptimer->list);	

	ptimer->next = p->pTimerCurrent;
	p->pTimerCurrent = ptimer;

	spin_unlock_irqrestore(&p->timer_lock, flags);

	return;	
}
